
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.*;
import javax.microedition.pim.*;
import java.io.*;
import java.util.*;

//-----------------------------------------------------------------------------
//classe excutant salatTimeCanvas.TimerCheck()  intervalle rgulier
class TimerPing extends TimerTask
{
  private SalatTimeCanvas salatTimeCanvas;

  TimerPing(SalatTimeCanvas salatTimeCanvas)
  {
    this.salatTimeCanvas = salatTimeCanvas;
  }

  public void run()
  {
	  salatTimeCanvas.TimerCheck();
  }
}
//-----------------------------------------------------------------------------
// Classe MIDLET
public class SalatTimeMidlet extends MIDlet implements CommandListener {
	public static final long DAY_TIME = 86400000;   
	private Display display;
	private Command computeCommand, exitCommand, aboutCommand, userdefCommand, configSCommand, exploreCommand, eventsCommand, kiblaCommand,
			computeExplored, ResetAfterExplored,
			setCommand, set_useCommand,
			selectPaysCommand, selectVilleCommand, backVilleCommand, infoSCommand, 
			generateCommand, backCommand;	//, detailsCommand;
	public SalatTimeCanvas salatTimeCanvas;
	private ConfigSCanvas configSCanvas;
	private UserDefForm userdefForm;
	private ExploreForm exploreForm;
	private KiblaCanvas kiblaCanvas;
	private EventsForm eventsForm;
	private TimerPing timerPing; // objet qui excute une mthode  intervalle rgulier
	private Timer timer; // gestion du temps
	private int alarmConfigInt;
//-----------------------------------------------------------------------------
	public SalatTimeMidlet() {
		display = Display.getDisplay(this);

		// salatTimeCanvas
		computeCommand 	= new Command ("Refresh", Command.OK, 0);
		configSCommand 	= new Command ("Config", Command.EXIT, 2);
		userdefCommand 	= new Command ("User Def", Command.EXIT, 2);
		exploreCommand 	= new Command ("Explore", Command.EXIT, 2);
		eventsCommand	= new Command ("Events", Command.EXIT, 2);
		kiblaCommand	= new Command ("Quibla", Command.EXIT, 2);
		aboutCommand 	= new Command ("About", Command.EXIT, 2);
		
		// exploreForm
		computeExplored	= new Command ("Compute", Command.OK, 0);
		ResetAfterExplored	= new Command ("Reset", Command.OK, 0);
		
		// eventsForm
		generateCommand = new Command ("Generate", Command.EXIT, 2);

		// userdefForm
		setCommand	 	= new Command ("Set", Command.EXIT, 3);
		set_useCommand	= new Command ("Set&Use", Command.EXIT, 2);
		
		exitCommand 	= new Command ("Exit", Command.EXIT, 1);

		// configSCanvas
		backCommand 	= new Command ("Back", Command.EXIT, 2);
		selectPaysCommand 	= new Command ("Select", Command.OK, 0);
		selectVilleCommand 	= new Command ("Select", Command.OK, 0);
		backVilleCommand 	= new Command ("Back", Command.EXIT, 2);
		infoSCommand 		= new Command ("Details", Command.EXIT, 2);
		
		salatTimeCanvas = new SalatTimeCanvas( this);
		salatTimeCanvas.addCommand (computeCommand);
		salatTimeCanvas.addCommand (exitCommand);
		salatTimeCanvas.addCommand (kiblaCommand);
		salatTimeCanvas.addCommand (eventsCommand);
		salatTimeCanvas.addCommand (configSCommand);
		salatTimeCanvas.addCommand (userdefCommand);
		salatTimeCanvas.addCommand (exploreCommand);
		salatTimeCanvas.addCommand (aboutCommand);
		salatTimeCanvas.setCommandListener (this);

		userdefForm=new UserDefForm(salatTimeCanvas.mr);
		userdefForm.addCommand (set_useCommand);
		userdefForm.addCommand (setCommand);
		userdefForm.addCommand (backCommand);
		userdefForm.setCommandListener (this);

		configSCanvas=new ConfigSCanvas(salatTimeCanvas.mr);
		configSCanvas.addCommand (selectPaysCommand);
//		configSCanvas.addCommand (infoSCommand);
		configSCanvas.addCommand (backCommand);
		configSCanvas.setCommandListener (this);

		kiblaCanvas=new KiblaCanvas(this);
		kiblaCanvas.addCommand (backCommand);
		kiblaCanvas.setCommandListener (this);
		
		eventsForm=new EventsForm(this);
		eventsForm.addCommand (backCommand);
		eventsForm.addCommand (generateCommand);
		eventsForm.setCommandListener (this);

		exploreForm = new ExploreForm ();
		exploreForm.addCommand (computeExplored);
		exploreForm.addCommand (backCommand);
		exploreForm.setCommandListener (this);
		
		timerPing=new TimerPing(salatTimeCanvas);
		timer=new Timer();
	}
//-----------------------------------------------------------------------------
    	  protected void startApp () {
					// cherche s'il y a deja des donnees persistants RPM
					RecupereRPM();
					salatTimeCanvas.mr.updateSelected(); 
					display.setCurrent (salatTimeCanvas);
					timer.schedule(timerPing, 1000, 1000); // toutes les 1 s, timerPing est appel
					 //qui appelera salatTimeCanvas.TimerCheck() 
					}
//-----------------------------------------------------------------------------
    	  protected void pauseApp () {
    	    // Do nothing
    	  }
//-----------------------------------------------------------------------------
    	  protected void destroyApp (boolean unconditional) {
      	    timer.cancel(); // arret du timer
    	    notifyDestroyed ();
   	  }
//-----------------------------------------------------------------------------
    	  public void commandAction (Command c, Displayable d) {
// dbut commandes du salatTimeCanvas
    		salatTimeCanvas.aboutFlag=false;
    		if (c == computeCommand && !salatTimeCanvas.EventsAdding) {
    	    	salatTimeCanvas.mr.GetDate();
    	    	salatTimeCanvas.mr.GetHeure();
    	    	salatTimeCanvas.mr.ComputeSalatTime();
						salatTimeCanvas.repaint();
						   	    	
    	    } else if (c == configSCommand) {
    	    	configSCanvas.indexpays=salatTimeCanvas.mr.Towns[salatTimeCanvas.mr.TownSelected].Country;
    	    	configSCanvas.indexville=salatTimeCanvas.mr.TownSelected;
    	    	configSCanvas.viewmode=1;	// pays
				display.setCurrent (configSCanvas);
				configSCanvas.repaint();
    	    	
    	    } else if (c == userdefCommand) {
    	    	userdefForm.TownName.setString(userdefForm.mr.Towns[0].TownName);
    	    	userdefForm.TimeZoneTown.setString(""+userdefForm.mr.Countries[0].TimeZoneTown);
    	    	userdefForm.DST.setString(""+userdefForm.mr.Countries[0].DST);
    	    	
    	    	userdefForm.Longitude.setString(""+userdefForm.mr.Towns[0].longitude);
    	    	userdefForm.Latitude.setString(""+userdefForm.mr.Towns[0].latitude);
  
    	    	userdefForm.Sunrise_setAngle.setString(""+userdefForm.mr.SalatTimeConfig[0].Sunrise_setAngle);
    	    	userdefForm.FajrTwilightAngle.setString(""+userdefForm.mr.SalatTimeConfig[0].FajrTwilightAngle);
    	    	userdefForm.IshaTwilightAngle.setString(""+userdefForm.mr.SalatTimeConfig[0].IshaTwilightAngle);
    	    	userdefForm.choiceBooleans[0]=userdefForm.mr.SalatTimeConfig[0].AsrShafi==1;		// AsrShafi
    	    	userdefForm.choiceBooleans[1]=userdefForm.mr.SalatTimeConfig[0].ZuhrFixe==1;	// ZuhrFixe
    	    	userdefForm.choiceBooleans[2]=userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus==1;	// Isha_is_Maghrib_plus
    			userdefForm.choices.setSelectedFlags(userdefForm.choiceBooleans);

    			userdefForm.ZuhrFixeHour.setString(""+userdefForm.mr.SalatTimeConfig[0].ZuhrFixeHour);
    	    	userdefForm.Isha_is_Maghrib_plus_min.setString(""+userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus_min);
    	    	
    	    	userdefForm.Adjust_Fajr.setString(		""+userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Fajr);
    	    	userdefForm.Adjust_Chourouk.setString(	""+userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Chourouk);
    	    	userdefForm.Adjust_Zuhr.setString(		""+userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Zuhr);
    	    	userdefForm.Adjust_Asr.setString(		""+userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Asr);
    	    	userdefForm.Adjust_Maghrib.setString(	""+userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Maghrib);
    	    	userdefForm.Adjust_Isha.setString(		""+userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Isha);
    	    	display.setCurrent (userdefForm);
    	    	
    	    } else if (c == exploreCommand) {
    	    	exploreForm.dateField.setDate(salatTimeCanvas.mr.calendarNow.getTime());
 				display.setCurrent (exploreForm);
				salatTimeCanvas.removeCommand(computeCommand);
				salatTimeCanvas.addCommand (ResetAfterExplored);
    	    	
    	    } else if (c == kiblaCommand) { // demande alarmForm
    	    	salatTimeCanvas.mr.Calc_haz();		// Position du soleil et Kibla
    	    	salatTimeCanvas.mr.CalculKibla();
    	    	display.setCurrent (kiblaCanvas);
    	    	kiblaCanvas.repaint();
    	    	
    	    } else if (c == eventsCommand) {	// demande la form de gnration d'Events
    	    	eventsForm.alarmChoice.setSelectedFlags(eventsForm.alarmBooleans);
    	    	eventsForm.Alarme_Fajr.setString(""+salatTimeCanvas.mr.Alarme_Fajr);
    	    	eventsForm.Alarme_Zuhr.setString(""+salatTimeCanvas.mr.Alarme_Zuhr);
    	    	eventsForm.Alarme_Asr.setString(""+salatTimeCanvas.mr.Alarme_Asr);
    	    	eventsForm.Alarme_Maghrib.setString(""+salatTimeCanvas.mr.Alarme_Maghrib);
    	    	eventsForm.Alarme_Isha.setString(""+salatTimeCanvas.mr.Alarme_Isha);
    	    	display.setCurrent (eventsForm);
				
    	    } else if (c == generateCommand) {	// demande la gnration d'Events
    	    	eventsForm.alarmChoice.getSelectedFlags(eventsForm.alarmBooleans);
    	    	salatTimeCanvas.mr.Alarme_Fajr=Integer.parseInt(eventsForm.Alarme_Fajr.getString()); 
    	    	salatTimeCanvas.mr.Alarme_Zuhr=Integer.parseInt(eventsForm.Alarme_Zuhr.getString());
    	    	salatTimeCanvas.mr.Alarme_Asr=Integer.parseInt(eventsForm.Alarme_Asr.getString());
    	    	salatTimeCanvas.mr.Alarme_Maghrib=Integer.parseInt(eventsForm.Alarme_Maghrib.getString());
    	    	salatTimeCanvas.mr.Alarme_Isha=Integer.parseInt(eventsForm.Alarme_Isha.getString());
    	    	// enregistrer dans le persistant RPM
    	    	alarmConfigInt=0;
    	    	if (eventsForm.alarmBooleans[0]) alarmConfigInt |=1;
    	    	if (eventsForm.alarmBooleans[1]) alarmConfigInt |=2;
    	    	if (eventsForm.alarmBooleans[2]) alarmConfigInt |=4;
    	    	if (eventsForm.alarmBooleans[3]) alarmConfigInt |=8;
    	    	if (eventsForm.alarmBooleans[4]) alarmConfigInt |=16;
    	    	RecordRPM();
    	    	// prise en compte du choix de l'utilisateur pour gnrer des calendrier Events
  	    	//Excute l'ajout ds le Calendrier un thread different
    	    	CalEventAdder eventAdder = new CalEventAdder();
        		Thread t = new Thread(eventAdder);
        		t.start();
        	// debug
//        		EventIt();
    	    	display.setCurrent (salatTimeCanvas);
				salatTimeCanvas.repaint();
				
    	    } else if (c == aboutCommand) {
    	    	salatTimeCanvas.aboutFlag=true;
    	    	salatTimeCanvas.repaint();
    	    	
    	    } else if (c == exitCommand) {
      	      destroyApp (true);
//  fin commandes du salatTimeCanvas
      	      
// dbut commandes du ExploreForm
    	    } else if (c == computeExplored) {
    	    	salatTimeCanvas.exploring=true;
    	       	salatTimeCanvas.mr.calendarNow.setTime(exploreForm.dateField.getDate());
    	    	salatTimeCanvas.mr.date.j=salatTimeCanvas.mr.calendarNow.get(Calendar.DATE);	
    	    	salatTimeCanvas.mr.date.m=salatTimeCanvas.mr.calendarNow.get(Calendar.MONTH)+1;
    	    	salatTimeCanvas.mr.date.a=salatTimeCanvas.mr.calendarNow.get(Calendar.YEAR);
    	    	display.setCurrent (salatTimeCanvas);
				salatTimeCanvas.mr.ComputeSalatTime();
				salatTimeCanvas.repaint();
// fin commandes du ExploreForm
								
    	    } else if (c == ResetAfterExplored) {
    	    	salatTimeCanvas.exploring=false;
 				salatTimeCanvas.removeCommand(ResetAfterExplored);
				salatTimeCanvas.addCommand (computeCommand);
				salatTimeCanvas.mr.GetDate();
    	    	salatTimeCanvas.mr.GetHeure();
    	    	salatTimeCanvas.mr.ComputeSalatTime();
    	    	salatTimeCanvas.repaint();
// dbut commandes du userdefForm
    	    } else if (c == setCommand) {
    	    	userdefForm.mr.Towns[0].TownName=userdefForm.TownName.getString();
    	    	userdefForm.mr.Countries[0].TimeZoneTown=Integer.parseInt(userdefForm.TimeZoneTown.getString());
    	    	userdefForm.mr.Countries[0].DST=Integer.parseInt(userdefForm.DST.getString());
    	    	
    	    	userdefForm.mr.Towns[0].longitude=Double.valueOf(userdefForm.Longitude.getString()).doubleValue();
    	    	userdefForm.mr.Towns[0].latitude=Double.valueOf(userdefForm.Latitude.getString()).doubleValue();

    	    	userdefForm.mr.SalatTimeConfig[0].Sunrise_setAngle=Double.valueOf(userdefForm.Sunrise_setAngle.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].FajrTwilightAngle=Double.valueOf(userdefForm.FajrTwilightAngle.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].IshaTwilightAngle=Double.valueOf(userdefForm.IshaTwilightAngle.getString()).doubleValue();
    	    	
  
    			userdefForm.choices.getSelectedFlags(userdefForm.choiceBooleans);
    	    	userdefForm.mr.SalatTimeConfig[0].AsrShafi=(userdefForm.choiceBooleans[0])? 1: 0;
    	    	userdefForm.mr.SalatTimeConfig[0].ZuhrFixe=(userdefForm.choiceBooleans[1])? 1: 0;
    	    	userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus=(userdefForm.choiceBooleans[2])? 1: 0;

       	    	userdefForm.mr.SalatTimeConfig[0].ZuhrFixeHour=Double.valueOf(userdefForm.ZuhrFixeHour.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus_min=Integer.parseInt(userdefForm.Isha_is_Maghrib_plus_min.getString());
     	    	
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Fajr=Double.valueOf(userdefForm.Adjust_Fajr.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Chourouk=Double.valueOf(userdefForm.Adjust_Chourouk.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Zuhr=Double.valueOf(userdefForm.Adjust_Zuhr.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Asr=Double.valueOf(userdefForm.Adjust_Asr.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Maghrib=Double.valueOf(userdefForm.Adjust_Maghrib.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Isha=Double.valueOf(userdefForm.Adjust_Isha.getString()).doubleValue();
//    	    	salatTimeCanvas.mr.updateSelected();
	       	    RecordRPM();
	       	    display.setCurrent (salatTimeCanvas);
				salatTimeCanvas.repaint();
				
    	    } else if (c == set_useCommand) {
    	    	userdefForm.mr.Towns[0].TownName=userdefForm.TownName.getString();
    	    	userdefForm.mr.Countries[0].TimeZoneTown=Integer.parseInt(userdefForm.TimeZoneTown.getString());
    	    	userdefForm.mr.Countries[0].DST=Integer.parseInt(userdefForm.DST.getString());
    	    	
    	    	userdefForm.mr.Towns[0].longitude=Double.valueOf(userdefForm.Longitude.getString()).doubleValue();
    	    	userdefForm.mr.Towns[0].latitude=Double.valueOf(userdefForm.Latitude.getString()).doubleValue();

    	    	userdefForm.mr.SalatTimeConfig[0].Sunrise_setAngle=Double.valueOf(userdefForm.Sunrise_setAngle.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].FajrTwilightAngle=Double.valueOf(userdefForm.FajrTwilightAngle.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].IshaTwilightAngle=Double.valueOf(userdefForm.IshaTwilightAngle.getString()).doubleValue();
    	    	
  
    			userdefForm.choices.getSelectedFlags(userdefForm.choiceBooleans);
    	    	userdefForm.mr.SalatTimeConfig[0].AsrShafi=(userdefForm.choiceBooleans[0])? 1: 0;
    	    	userdefForm.mr.SalatTimeConfig[0].ZuhrFixe=(userdefForm.choiceBooleans[1])? 1: 0;
    	    	userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus=(userdefForm.choiceBooleans[2])? 1: 0;

    	    	userdefForm.mr.SalatTimeConfig[0].ZuhrFixeHour=Double.valueOf(userdefForm.ZuhrFixeHour.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus_min=Integer.parseInt(userdefForm.Isha_is_Maghrib_plus_min.getString());
     	    	
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Fajr=Double.valueOf(userdefForm.Adjust_Fajr.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Chourouk=Double.valueOf(userdefForm.Adjust_Chourouk.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Zuhr=Double.valueOf(userdefForm.Adjust_Zuhr.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Asr=Double.valueOf(userdefForm.Adjust_Asr.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Maghrib=Double.valueOf(userdefForm.Adjust_Maghrib.getString()).doubleValue();
    	    	userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Isha=Double.valueOf(userdefForm.Adjust_Isha.getString()).doubleValue();
    	    	salatTimeCanvas.mr.TownSelected=0;	// Ville du User Define
				salatTimeCanvas.mr.updateSelected();
	       	    RecordRPM();
	       	    display.setCurrent (salatTimeCanvas);
				salatTimeCanvas.repaint();
//				
//    	    } else if (c == detailsCommand) {
//    	    	configCanvas.detailSelected=true;
//				configCanvas.repaint();
// fin commandes du userdefForm
// dbut commandes du configSCanvas
    	    } else if (c == backCommand) {
    	    	if (configSCanvas.detailSelected)	{
    												configSCanvas.detailSelected=false;
									    	    	configSCanvas.repaint();
									    	    	}
					    		else	{
										display.setCurrent (salatTimeCanvas);
										salatTimeCanvas.repaint();
					    				}
    	    } else if (c == selectPaysCommand) { 		//Apres le choix du pays, on passe au choix de la ville
				configSCanvas.removeCommand(selectPaysCommand);
    			configSCanvas.removeCommand (backCommand);
    			configSCanvas.addCommand (selectVilleCommand);
       			configSCanvas.addCommand(backVilleCommand);
       			configSCanvas.detailSelected=false;
    			configSCanvas.viewmode=2;	
    			if (configSCanvas.indexville < salatTimeCanvas.mr.Countries[configSCanvas.indexpays].debut)		configSCanvas.indexville = salatTimeCanvas.mr.Countries[configSCanvas.indexpays].debut;
    			if (configSCanvas.indexville > salatTimeCanvas.mr.Countries[configSCanvas.indexpays].fin-1)		configSCanvas.indexville = salatTimeCanvas.mr.Countries[configSCanvas.indexpays].fin-1;
    			configSCanvas.repaint();
				
    	    } else if (c == selectVilleCommand) {
    	    	salatTimeCanvas.mr.TownSelected=configSCanvas.indexville;
        	    RecordRPM();
				salatTimeCanvas.mr.updateSelected();
	   			configSCanvas.removeCommand(selectVilleCommand);
       			configSCanvas.removeCommand(backVilleCommand);
    			configSCanvas.addCommand (selectPaysCommand);
    			configSCanvas.addCommand(backCommand);
    			configSCanvas.viewmode=1;	// sera remis encore au prochain appel
    			display.setCurrent (salatTimeCanvas);
				salatTimeCanvas.repaint();
				
    	    } else if (c == backVilleCommand) {
    	    	if (configSCanvas.detailSelected)	configSCanvas.detailSelected=false;
    	    		else	{
	    	    	    	configSCanvas.viewmode=1;	
	    	    			configSCanvas.removeCommand(selectVilleCommand);
							configSCanvas.removeCommand(backVilleCommand);
							configSCanvas.addCommand(backCommand);
	    	    			configSCanvas.addCommand (selectPaysCommand);
    	    				}
    			configSCanvas.repaint();
				
    	    } else if (c == infoSCommand) {
    			configSCanvas.repaint();
//fin commandes du configSCanvas
    	    }
    	  }
//---------------------------------------------------------------------------
//    	 Adds event to calendar in seperate thread
//    	public void EventIt() {
      private class CalEventAdder implements Runnable {
    	public static final int MINUTE_TIME = 60;   
    	public void run() {
 			// Delete then record events ds le PIM
    		System.out.println("Debut Events Generation");
	        salatTimeCanvas.EventsAdding=true;		// afin d'eviter le renouvellement des calculs
			EventList eventList=null;
			Enumeration enumeration = null;
	        // il faut effacer tous les events dont la note commence par "Salat "
	        // entre la dates eventsForm.Debut.getDate() et eventsForm.Fin.getDate()
	        // puis ajouter entre now et eventsForm.Fin.getDate()   les Salat que l'on demande
	        String evsummary;
	        long evdate, debutdate, findate;
	        debutdate=eventsForm.Debut.getDate().getTime();		// long de l'heure de debut de la zone de travail
	        findate=eventsForm.Fin.getDate().getTime();		// long de l'heure de fin de la zone de travail
	        System.out.println("Dbut : "+debutdate + "  Fin : "+findate);
			// procede  la recherche de la liste entre dbut et fin
	        try	{
	            eventList = (EventList)PIM.getInstance().openPIMList(PIM.EVENT_LIST,PIM.READ_WRITE); //
	            enumeration = eventList.items(EventList.STARTING, debutdate, findate, true);
//	            enumeration = eventList.items();
	        	}
	        catch(SecurityException e){
	            System.out.println("Je n'ai pas t autoris  y accder : "+e.toString());
	            salatTimeCanvas.EventsAdding=false;
	            return;
	      		}
	        catch(PIMException e){
	            System.out.println("j'arrive pas  ouvrir l'eventList, pb PIMException    "+e.toString());
	            salatTimeCanvas.EventsAdding=false;
	            return;
	      		}
	        if (!eventList.isSupportedField(Event.SUMMARY) || ! eventList.isSupportedField(Event.START))
        		{
	        	System.out.println("eventList ne supporte pas Event.SUMMARY et Event.START");
	            salatTimeCanvas.EventsAdding=false;
	            return;
	      		}
	        System.out.println("--------------------------------------------------------");
	        System.out.println("Event liste OK ----------- dbut delete Events");
        try {
	        while(enumeration != null && enumeration.hasMoreElements())		// parcours la liste des events
	        	{
	            Event ev = (Event)enumeration.nextElement();
	        	evsummary= ev.getString(Event.SUMMARY, 0);
	        	if (evsummary.startsWith("Salat "))		//  la recherche de ceux qui commencent par "Salat "
	        		{
	        		evdate= ev.getDate(Event.START, 0);
	        		System.out.println( evsummary+" date : "+evdate+"  ie  "+ev.toString());
					if (evdate>=debutdate && evdate<findate)
							{// efface l'event ev
							try	{
					            eventList.removeEvent(ev);
					        	}
					        catch(PIMException e){
					            System.out.println("j'arrive pas  effacer l'event, pb PIMException    "+e.toString());
					            salatTimeCanvas.EventsAdding=false;
					            return;
					      		}
							}
			        }
	        	}
        	}
        catch (java.lang.IndexOutOfBoundsException  exs)
        {
        	 System.out.println("java.lang.IndexOutOfBoundsException    "+exs.toString());
	            salatTimeCanvas.EventsAdding=false;
//	            return;	
        }
	        System.out.println("Fin d'effacement des vnements");
	        // ajoute les events entre nowdate et findate
	        Calendar Instantcal= Calendar.getInstance();
	        Instantcal.setTime(new Date(System.currentTimeMillis()));
	        while (Instantcal.getTime().getTime() <= findate
	        		&& Instantcal.getTime().getTime() > debutdate)	// itre sur les jours
				{
	        	salatTimeCanvas.mr.calendarNow.setTime( new Date(Instantcal.getTime().getTime()));
    	    	salatTimeCanvas.mr.date.j=salatTimeCanvas.mr.calendarNow.get(Calendar.DATE);	
    	    	salatTimeCanvas.mr.date.m=salatTimeCanvas.mr.calendarNow.get(Calendar.MONTH)+1;
    	    	salatTimeCanvas.mr.date.a=salatTimeCanvas.mr.calendarNow.get(Calendar.YEAR);
    	    	System.out.println("Date considre :"+salatTimeCanvas.mr.date.j+"/"+salatTimeCanvas.mr.date.m+"/"+salatTimeCanvas.mr.date.a);
    	    	System.out.println("Date considre calendarNow en long :"+Instantcal.getTime().getTime());
    	    	salatTimeCanvas.mr.ComputeSalatTime();
				
				// ajoute le Fajr s'il est demand
				if (eventsForm.alarmBooleans[0])
					{// convertit l'heure de Fajr en Date et lance une alarme
					Date AlrmDate=new Date(h2DateEvent(salatTimeCanvas.mr.SalatTimeC.Fajr, Instantcal.getTime()));
					System.out.println("Fajr en long :"+AlrmDate.getTime());
					Event event = eventList.createEvent();
					if (eventList.isSupportedField(Event.SUMMARY))
				        event.addString(Event.SUMMARY, PIMItem.ATTR_NONE, "Salat Fajr");
					if (eventList.isSupportedField(Event.START))
					        event.addDate(Event.START, PIMItem.ATTR_NONE, AlrmDate.getTime());
					if (eventList.isSupportedField(Event.ALARM))
					        event.addInt(Event.ALARM, PIMItem.ATTR_NONE, salatTimeCanvas.mr.Alarme_Fajr*MINUTE_TIME);
					System.out.println("Event Salat Fajr prpar OK");
					try	{
						event.commit();	// enregistre l'event ds le PIM
						System.out.println("Event ajout : Salat Fajr "+AlrmDate.getTime());
						}
					catch(Exception e){
					    System.out.println("j'arrive pas  enregister l'event    "+e.toString());
						}
					System.out.println("*******************");
					}
				
				// ajoute le Zuhr s'il est demand
				if (eventsForm.alarmBooleans[1])
					{// convertit l'heure de Zuhr en Date et lance une alarme
					Date AlrmDate=new Date(h2DateEvent(salatTimeCanvas.mr.SalatTimeC.Zuhr, Instantcal.getTime()));
					System.out.println("Zuhr en long :"+AlrmDate.getTime());
					Event event = eventList.createEvent();
					if (eventList.isSupportedField(Event.SUMMARY))
				        event.addString(Event.SUMMARY, PIMItem.ATTR_NONE, "Salat Zuhr");
					if (eventList.isSupportedField(Event.START))
					        event.addDate(Event.START, PIMItem.ATTR_NONE, AlrmDate.getTime());
					if (eventList.isSupportedField(Event.ALARM))
					        event.addInt(Event.ALARM, PIMItem.ATTR_NONE, salatTimeCanvas.mr.Alarme_Zuhr*MINUTE_TIME);
					System.out.println("Event Salat Fajr prpar OK");
					try	{
						event.commit();	// enregistre l'event ds le PIM
						System.out.println("Event ajout : Salat Zuhr "+AlrmDate.getTime());
						}
					catch(Exception e){
					    System.out.println("j'arrive pas  enregister l'event    "+e.toString());
						}
					System.out.println("*******************");
					}
				
				// ajoute le Asr s'il est demand
				if (eventsForm.alarmBooleans[2])
					{// convertit l'heure de Asr en Date et lance une alarme
					Date AlrmDate=new Date(h2DateEvent(salatTimeCanvas.mr.SalatTimeC.Asr, Instantcal.getTime()));
					System.out.println("Asr en long :"+AlrmDate.getTime());
					Event event = eventList.createEvent();
					if (eventList.isSupportedField(Event.SUMMARY))
				        event.addString(Event.SUMMARY, PIMItem.ATTR_NONE, "Salat Asr");
					if (eventList.isSupportedField(Event.START))
					        event.addDate(Event.START, PIMItem.ATTR_NONE, AlrmDate.getTime());
					if (eventList.isSupportedField(Event.ALARM))
					        event.addInt(Event.ALARM, PIMItem.ATTR_NONE, salatTimeCanvas.mr.Alarme_Asr*MINUTE_TIME);
					System.out.println("Event Salat Fajr prpar OK");
					try	{
						event.commit();	// enregistre l'event ds le PIM
						System.out.println("Event ajout : Salat Asr "+AlrmDate.getTime());
						}
					catch(Exception e){
					    System.out.println("j'arrive pas  enregister l'event    "+e.toString());
						}
					System.out.println("*******************");
					}
				
				// ajoute le Maghrib s'il est demand
				if (eventsForm.alarmBooleans[3])
					{// convertit l'heure de Maghrib en Date et lance une alarme
					Date AlrmDate=new Date(h2DateEvent(salatTimeCanvas.mr.SalatTimeC.Maghrib, Instantcal.getTime()));
					System.out.println("Maghrib en long :"+AlrmDate.getTime());
					Event event = eventList.createEvent();
					if (eventList.isSupportedField(Event.SUMMARY))
				        event.addString(Event.SUMMARY, PIMItem.ATTR_NONE, "Salat Maghrib");
					if (eventList.isSupportedField(Event.START))
					        event.addDate(Event.START, PIMItem.ATTR_NONE, AlrmDate.getTime());
					if (eventList.isSupportedField(Event.ALARM))
					        event.addInt(Event.ALARM, PIMItem.ATTR_NONE, salatTimeCanvas.mr.Alarme_Maghrib*MINUTE_TIME);
					System.out.println("Event Salat Fajr prpar OK");
					try	{
						event.commit();	// enregistre l'event ds le PIM
						System.out.println("Event ajout : Salat Maghrib "+AlrmDate.getTime());
						}
					catch(Exception e){
					    System.out.println("j'arrive pas  enregister l'event    "+e.toString());
						}
					System.out.println("*******************");
					}
				
				// ajoute le Isha s'il est demand
				if (eventsForm.alarmBooleans[4])
					{// convertit l'heure de Isha en Date et lance une alarme
					Date AlrmDate=new Date(h2DateEvent(salatTimeCanvas.mr.SalatTimeC.Isha, Instantcal.getTime()));
					System.out.println("Isha en long :"+AlrmDate.getTime());
					Event event = eventList.createEvent();
					if (eventList.isSupportedField(Event.SUMMARY))
				        event.addString(Event.SUMMARY, PIMItem.ATTR_NONE, "Salat Isha");
					if (eventList.isSupportedField(Event.START))
					        event.addDate(Event.START, PIMItem.ATTR_NONE, AlrmDate.getTime());
					if (eventList.isSupportedField(Event.ALARM))
					        event.addInt(Event.ALARM, PIMItem.ATTR_NONE, salatTimeCanvas.mr.Alarme_Isha*MINUTE_TIME);
					System.out.println("Event Salat Fajr prpar OK");
					try	{
						event.commit();	// enregistre l'event ds le PIM
						System.out.println("Event ajout : Salat Isha "+AlrmDate.getTime());
						}
					catch(Exception e){
					    System.out.println("j'arrive pas  enregister l'event    "+e.toString());
						}
					System.out.println("*******************");
					}
				
				// avance d'1 jour
				Instantcal.setTime( new Date(Instantcal.getTime().getTime()+DAY_TIME));
				}// fin du while sur les jours
          try {
          	eventList.close();
          	}
          catch (PIMException e) {
          	System.out.println("j'arrive pas  fermer");
          	}
		System.out.println("*********************************************************");
        // remet l'heure et le bon calcul
        salatTimeCanvas.mr.GetDate();
	    salatTimeCanvas.mr.GetHeure();
	    salatTimeCanvas.EventsAdding=false;
	    salatTimeCanvas.mr.ComputeSalatTime();
		salatTimeCanvas.repaint();
    	}
}    	  
//---------------------------------------------------------------------------
	void RecupereRPM()
			{
    		// lit s'il y a une ville enregistre
    			salatTimeCanvas.mr.TownSelected =276;	// par dfaut Nancy
					boolean FirstTime=false;
  		    try {
	    		salatTimeCanvas.mr.db= RecordStore.openRecordStore("myDBSalatTime", true);
				  // verif si c'est la 1ere fois qu'on ecrit la db
					if( salatTimeCanvas.mr.db.getNumRecords() == 0 )
										{ // la remplir
										ByteArrayOutputStream baos = new ByteArrayOutputStream();
										DataOutputStream dos = new DataOutputStream(baos);
										RecordRPMUserDefine( dos); // la vraie recuperation de l'enregistrement unique
										byte[] b = baos.toByteArray();
												try {
													salatTimeCanvas.mr.db.addRecord(b, 0, b.length);
											} catch (RecordStoreException rse) {
													rse.printStackTrace ();
												}	
										FirstTime=true;
										}
  		    	} catch (RecordStoreException rse) {
  		    		rse.printStackTrace ();
  		    	}

					if( !FirstTime )
										{ // la table existe dj et donc la vile :je rcupre
										ByteArrayInputStream bais=null;
										try {
										//int recordId = salatTimeCanvas.mr.db.enumerateRecords(null, null, true).nextRecordId();
										bais = new ByteArrayInputStream(salatTimeCanvas.mr.db.getRecord(1));
												} catch (RecordStoreException rse) {
													rse.printStackTrace ();
												}
										//ByteArrayInputStream bais = new	ByteArrayInputStream(recordId);
										DataInputStream dis = new DataInputStream(bais);
										RecupereRPMUserDefine( dis);
										}
					// fermeture de la db
					try {
					 salatTimeCanvas.mr.db.closeRecordStore();
					} catch (RecordStoreException rse) {
						rse.printStackTrace ();
					}
			}
//---------------------------------------------------------------------------
	void RecupereRPMUserDefine(DataInputStream dis)
			{
		try {
			salatTimeCanvas.mr.TownSelected = dis.readInt();
			configSCanvas.indexpays=salatTimeCanvas.mr.TownSelected;
			alarmConfigInt = dis.readInt();
			eventsForm.alarmBooleans[0]=(alarmConfigInt & 1)==1;
			eventsForm.alarmBooleans[1]=(alarmConfigInt & 2)==2;
			eventsForm.alarmBooleans[2]=(alarmConfigInt & 4)==4;
			eventsForm.alarmBooleans[3]=(alarmConfigInt & 8)==8;
			eventsForm.alarmBooleans[4]=(alarmConfigInt & 16)==16;
			System.out.println("Ville lue : N"+salatTimeCanvas.mr.TownSelected);
			System.out.println("Alarm Config Int : "+alarmConfigInt);
			
			userdefForm.mr.Towns[0].TownName = dis.readUTF();
			userdefForm.mr.Countries[0].TimeZoneTown = dis.readInt();
			userdefForm.mr.Countries[0].DST = dis.readInt();
			userdefForm.mr.Towns[0].latitude= dis.readDouble();
			userdefForm.mr.Towns[0].longitude= dis.readDouble();
			
			userdefForm.mr.SalatTimeConfig[0].Sunrise_setAngle= dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].FajrTwilightAngle= dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].IshaTwilightAngle= dis.readDouble();

			userdefForm.mr.SalatTimeConfig[0].AsrShafi= dis.readInt();
			userdefForm.mr.SalatTimeConfig[0].ZuhrFixe= dis.readInt();
			userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus= dis.readInt();

			userdefForm.mr.SalatTimeConfig[0].ZuhrFixeHour= dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus_min= dis.readInt();

			userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Fajr = dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Chourouk = dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Zuhr = dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Asr = dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Maghrib = dis.readDouble();
			userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Isha = dis.readDouble();
			System.out.println("Lecture des donnes RPM User Define");		
			
			userdefForm.mr.Alarme_Fajr = dis.readInt();
			userdefForm.mr.Alarme_Zuhr = dis.readInt();
			userdefForm.mr.Alarme_Asr = dis.readInt();
			userdefForm.mr.Alarme_Maghrib = dis.readInt();
			userdefForm.mr.Alarme_Isha = dis.readInt();
			System.out.println("Lecture des donnes RMS Alarme Salat");			
			} catch (Exception e) {
					e.printStackTrace();
			} 
		}
//---------------------------------------------------------------------------
		void RecordRPM()
			{
		    try {
	    		salatTimeCanvas.mr.db= RecordStore.openRecordStore("myDBSalatTime", true);
		    	} catch (RecordStoreException rse) {
		    		rse.printStackTrace ();
		    	}	
    	    ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream dos = new DataOutputStream(baos);
			RecordRPMUserDefine( dos);
			byte[] b = baos.toByteArray();
		    try {
//		    	salatTimeCanvas.mr.db.addRecord(b, 0, b.length);
				salatTimeCanvas.mr.db.setRecord(1, b, 0, b.length);	
			} catch (RecordStoreException rse) {
		    		rse.printStackTrace ();
		    	}	
		    try {
		    	 salatTimeCanvas.mr.db.closeRecordStore();
		    	} catch (RecordStoreException rse) {
		    		rse.printStackTrace ();
		    	}
		    System.out.println("Enregistrement de la config : Ville : N"+salatTimeCanvas.mr.TownSelected
		    					+" Alarm Config Int : "+alarmConfigInt);
			}
//---------------------------------------------------------------------------
		void RecordRPMUserDefine(DataOutputStream dos)
			{
			try {
				dos.writeInt(salatTimeCanvas.mr.TownSelected);
				dos.writeInt(alarmConfigInt);
				
				dos.writeUTF(userdefForm.mr.Towns[0].TownName);
				dos.writeInt(userdefForm.mr.Countries[0].TimeZoneTown);
				dos.writeInt(userdefForm.mr.Countries[0].DST);
				dos.writeDouble(userdefForm.mr.Towns[0].latitude);
				dos.writeDouble(userdefForm.mr.Towns[0].longitude);

				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].Sunrise_setAngle);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].FajrTwilightAngle);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].IshaTwilightAngle);

				dos.writeInt(userdefForm.mr.SalatTimeConfig[0].AsrShafi);
				dos.writeInt(userdefForm.mr.SalatTimeConfig[0].ZuhrFixe);
				dos.writeInt(userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus);

				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].ZuhrFixeHour);
       	    	dos.writeInt(userdefForm.mr.SalatTimeConfig[0].Isha_is_Maghrib_plus_min);

				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Fajr);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Chourouk);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Zuhr);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Asr);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Maghrib);
				dos.writeDouble(userdefForm.mr.SalatTimeConfig[0].SalatTimeAdjust.Isha);
				
				dos.writeInt(userdefForm.mr.Alarme_Fajr);
				dos.writeInt(userdefForm.mr.Alarme_Zuhr);
				dos.writeInt(userdefForm.mr.Alarme_Asr);
				dos.writeInt(userdefForm.mr.Alarme_Maghrib);
				dos.writeInt(userdefForm.mr.Alarme_Isha);
			} catch (IOException ioe) {
				ioe.printStackTrace();
			} 
		    System.out.println("Enregistrement de la config : Convention : N0");
			}
//---------------------------------------------------------------------------
//convert h en h min arondie puis en Date
    	long h2DateEvent( double h , Date day)
    	{
		Calendar cal= Calendar.getInstance();
        cal.setTime(new Date(day.getTime()));
    	double m, s;
    	int hi, mi;
    		hi=(int)h;
    		m=(h-hi)*60;
    		mi=(int)((h-hi)*60);
    		s=(m-mi)*60;
    		if (s>=30)	{
    					mi++;
    					if (mi==60)	{
    								mi=0; hi++;
    								if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
    											//sprintf(SS, "erreur : arrondi au jour suivant");
    									System.out.println("erreur : arrondi au jour suivant");
    									return cal.getTime().getTime();
    							                }	
    								}
    								}
    		System.out.println("heure convertie en "+hi+":"+mi);
            cal.set(Calendar.HOUR_OF_DAY, hi);
            cal.set(Calendar.MINUTE, mi);
            cal.set(Calendar.SECOND, 0);	// sonne au dbut de la minute
            return cal.getTime().getTime();
    	}
//---------------------------------------------------------------------------
//convert h en h min arondie puis en Date
    	Date h2Date( double h)
    	{
		Calendar cal= Calendar.getInstance();
        cal.setTime(new Date(System.currentTimeMillis()));
    	double m, s;
    	int hi, mi;
    		hi=(int)h;
    		m=(h-hi)*60;
    		mi=(int)((h-hi)*60);
    		s=(m-mi)*60;
    		if (s>=30)	{
    					mi++;
    					if (mi==60)	{
    								mi=0; hi++;
    								if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
    											//sprintf(SS, "erreur : arrondi au jour suivant");
    									System.out.println("erreur : arrondi au jour suivant");
    									return cal.getTime();
    							                }	
    								}
    								}
    		System.out.println("heure convertie en "+hi+":"+mi);
            cal.set(Calendar.HOUR_OF_DAY, hi);
            cal.set(Calendar.MINUTE, mi);
            cal.set(Calendar.SECOND, 0);	// sonne au dbut de la minute
            return cal.getTime();
    	}
//-----------------------------------------------------------------------------
}
