

import java.util.*;
import javax.microedition.rms.*;

//-----------------------------------------------------------------------------
class Astre {
	public double az,  h,      // coord. horizontal
				delta,  tau, // coord equatorial
				RA,                // ascension droite
				L;                //longitude rele
	}
//-----------------------------------------------------------------------------
class SalatTimeStruct  { double Fajr, Chourouk, Zuhr, Asr, Maghrib, Isha;}
//-----------------------------------------------------------------------------
class DateUT  { int j, m, a; double h; // jour/mois/anne/heure.xxx
	} 
//-----------------------------------------------------------------------------
class Heure  { int ms, s, m, h;  // milisec, secondes/, minutes, heures
	}
//-----------------------------------------------------------------------------
class CountryData {
	String CountryName;
	int TimeZoneTown, Convention, DST, debut, fin;
	}
//-----------------------------------------------------------------------------
class TownData {
	int Country;
	String TownName;
	double longitude, latitude;
	public TownData(int C, String T, double lat, double lon)
		{ Country=C; TownName=T; latitude=lat; longitude=lon; }
	}
//-----------------------------------------------------------------------------
class SalatTimeConfigStruct {
	SalatTimeStruct  SalatTimeAdjust;
	int AsrShafi, Isha_is_Maghrib_plus, ZuhrFixe;
	double FajrTwilightAngle, IshaTwilightAngle, Sunrise_setAngle;
	int Isha_is_Maghrib_plus_min;
	double ZuhrFixeHour;
	String name;
	public SalatTimeConfigStruct() {
		SalatTimeAdjust=new SalatTimeStruct();
		}
	}
//-----------------------------------------------------------------------------
//		 routine principale
//-----------------------------------------------------------------------------
public class mainroutines {
	static final double M_PI=3.1415926535897932384626433832795;
	static final double deg2rd = 0.017453292519943295769236907684886;
	static final double rd2deg = 57.295779513082320876798154814105;
	static final double heure2rd = 0.26179938779914943653855361527329;
	static final double rd2heure = 3.8197186342054880584532103209403;
	static final double SolarSiderealCorrection = 1.002738;
	//---------------------------------------------------------------------------
	static final byte idFajr=0;
	static final byte idChourouk=1;
	static final byte idZuhr=2;
	static final byte idAsr=3;
	static final byte idMaghrib=4;
	static final byte idIsha=5;

	static final byte NConvention= 5; 	// normalement 8;

	static final int debut_UserDefined=	0,									fin_UserDefined=debut_UserDefined+	1;
	static final int debut_Algerie=			fin_UserDefined,		fin_Algerie=debut_Algerie+					32;
	static final int debut_Belgique=		fin_Algerie,				fin_Belgique=debut_Belgique+				128;
	static final int debut_France=			fin_Belgique,				fin_France=debut_France+						184;
	static final int debut_Luxembourg=	fin_France,					fin_Luxembourg=debut_Luxembourg+		12;
	static final int debut_Maroc=				fin_Luxembourg,			fin_Maroc=debut_Maroc+							40;
	static final int debut_Tunisie=			fin_Maroc,					fin_Tunisie=debut_Tunisie+					80;
	static final int debut_Suisse=			fin_Tunisie,				fin_Suisse=debut_Suisse+						126;

	public SalatTimeCanvas canvas;
	public Astre Soleil;
	public SalatTimeStruct SalatTime, SalatTimeC;
	public double JD, T,  // Jour Julien, Julien Century : T,
					theta0, theta,  // theta0 : temps sideral  Greenwich
					longitude, latitude, thetaKibla;
//debug
	public DateUT date, LastComputeDate; // date en jours
	public Heure heure;
	public Calendar calendarNow;
	public boolean Verbose, DSTApplies, validSalatTimeC, limitValid;
	static final int limitValidYear=2009;	// limite de validit du programme
	static final int NTowns=fin_Suisse;		// nombre de villes : dclares en statique 1+32+128+184+12+22+80+127=586
	static final int NCountries=8;		// nombre de Pays : dclares en statique
	
	public String CountryName, TownName;
	public int MyTimeZone, TimeZoneTown, TownSelected, Convention, DST;
	public RecordStore db=null;
	public int Alarme_Fajr, Alarme_Zuhr, Alarme_Asr, Alarme_Maghrib, Alarme_Isha;
	public SalatTimeConfigStruct [] SalatTimeConfig;
//	public TownData [] Towns;
	public CountryData [] Countries;
	public String [] Mounths={"Janvier", "Fvrier", "Mars", "Avril",
									"Mai", "Juin", "Juillet", "Aot",
									"Septembre", "Octobre", "Novembre", "Dcembre"};
	public String [] Days={"Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi", "Samedi", "Dimanche"};
// constantes : coord des villes :
//	Towns[TownsCount].Country=1;Towns[TownsCount].TownName="Adrar";Towns[TownsCount].latitude=27.8676;Towns[TownsCount].longitude=-0.289842;TownsCount++;

	public static final TownData[] Towns;
	static {
		Towns=new TownData[] {
//379 towns
					new TownData(0, "User Defined", 45.0, 6.0 ),

					new TownData(1, "Adrar", 27.8676, -0.289842 ),
					new TownData(1, "Alger", 36.7529, 3.04205 ),
					new TownData(1, "Annaba", 36.9029, 7.75554 ),
					new TownData(1, "Batna", 35.5572, 6.17229 ),
					new TownData(1, "Bchar", 31.6082, -2.22001 ),
					new TownData(1, "Bjaa", 36.7567, 5.07809 ),
					new TownData(1, "Biskra", 34.8568, 5.72687 ),
					new TownData(1, "Blida", 36.4805, 2.8339 ),
					new TownData(1, "Bouira", 36.3806, 3.89698 ),
					new TownData(1, "Constantine", 36.36, 6.60946 ),
					new TownData(1, "Djelfa", 34.6805, 3.2499 ),
					new TownData(1, "El-Bayadh", 33.6935, 1.01534 ),
					new TownData(1, "El-Oued", 33.3683, 6.86737 ),
					new TownData(1, "Guelma", 36.4659, 7.42836 ),
					new TownData(1, "Jijel", 36.8219, 5.7661 ),
					new TownData(1, "Laghouat", 33.8066, 2.87803 ),
					new TownData(1, "Mascara", 35.4002, 0.139852 ),
					new TownData(1, "Medea", 36.2673, 2.77609 ),
					new TownData(1, "Mila", 36.4502, 6.26538 ),
					new TownData(1, "Oran", 35.7051, -0.637093 ),
					new TownData(1, "Ouargla", 31.963, 5.34201 ),
					new TownData(1, "Oum-El-Bouaghi", 35.8819, 7.11704 ),
					new TownData(1, "Relizane", 35.7422, 0.661006 ),
					new TownData(1, "Sada", 34.8408, 0.149473 ),
					new TownData(1, "Stif", 36.189, 5.41442 ),
					new TownData(1, "Sidi-Bel-Abbs", 35.1999, -0.635242 ),
					new TownData(1, "Souk-Ahras", 36.2838, 7.95538 ),
					new TownData(1, "Tebessa", 35.4071, 8.12086 ),
					new TownData(1, "Tiaret", 35.3785, 1.32569 ),
					new TownData(1, "Tissemsilt", 35.6102, 1.81131 ),
					new TownData(1, "Tizi-Ouzou", 36.7191, 4.05036 ),
					new TownData(1, "Tlemcen", 34.8825, -1.31393 ),

				new TownData(2, "Aarschot", 50.9955, 4.85549 ),
				new TownData(2, "Alostnew TownData(Aalst)", 50.9375, 4.04108 ),
				new TownData(2, "Andenne", 50.4894, 5.06284 ),
				new TownData(2, "Antoing", 50.5578, 3.4683 ),
				new TownData(2, "Anversnew TownData(Antwerpen)", 51.2606, 4.35819 ),
				new TownData(2, "Arlon", 49.6746, 5.79472 ),
				new TownData(2, "Ath", 50.6299, 3.78402 ),
				new TownData(2, "Audenardenew TownData(Oudenaarde)", 50.8427, 3.60404 ),
				new TownData(2, "Bastogne", 50.0131, 5.75301 ),
				new TownData(2, "Beaumont", 50.2268, 4.25532 ),
				new TownData(2, "Beauraing", 50.0916, 4.94977 ),
				new TownData(2, "Beringen", 51.0611, 5.23286 ),
				new TownData(2, "Bilzen", 50.8695, 5.53295 ),
				new TownData(2, "Binche", 50.3982, 4.15408 ),
				new TownData(2, "Blankenberge", 51.2999, 3.14057 ),
				new TownData(2, "Bouillon", 49.7965, 5.07924 ),
				new TownData(2, "Braine-le-Comte", 50.6167, 4.1398 ),
				new TownData(2, "Bree", 51.1436, 5.63252 ),
				new TownData(2, "Brugesnew TownData(Brugge)", 51.2094, 3.22523 ),
				new TownData(2, "Bruxelles", 50.8549, 4.3755 ),
				new TownData(2, "Charleroi", 50.4227, 4.42765 ),
				new TownData(2, "Chtelet", 50.4059, 4.5236 ),
				new TownData(2, "Chivres", 50.5701, 3.77578 ),
				new TownData(2, "Chimay", 50.0354, 4.32126 ),
				new TownData(2, "Chiny", 49.7214, 5.39591 ),
				new TownData(2, "Ciney", 50.2745, 5.13193 ),
				new TownData(2, "Comines-Warneton", 50.7515, 2.93603 ),
				new TownData(2, "Courtrainew TownData(Kortrijk)", 50.828, 3.26503 ),
				new TownData(2, "Couvin", 50.0386, 4.49542 ),
				new TownData(2, "Damme", 51.2501, 3.32281 ),
				new TownData(2, "Deinze", 50.9888, 3.5122 ),
				new TownData(2, "Diest", 50.9965, 5.07712 ),
				new TownData(2, "Dilsen-Stokkem", 51.0392, 5.71158 ),
				new TownData(2, "Dinant", 50.2425, 4.95124 ),
				new TownData(2, "Dixmudenew TownData(Diksmuide)", 51.0318, 2.86377 ),
				new TownData(2, "Durbuy", 50.3648, 5.48933 ),
				new TownData(2, "Eeklo", 51.1906, 3.55876 ),
				new TownData(2, "Enghien", 50.6715, 4.03745 ),
				new TownData(2, "Eupen", 50.6104, 6.13488 ),
				new TownData(2, "Fleurus", 50.4903, 4.53934 ),
				new TownData(2, "Florenville", 49.696, 5.28588 ),
				new TownData(2, "Fontaine-l'vque", 50.4067, 4.32359 ),
				new TownData(2, "Fosses-la-Ville", 50.3932, 4.69168 ),
				new TownData(2, "Furnesnew TownData(Veurne)", 51.0727, 2.66251 ),
				new TownData(2, "Gandnew TownData(Gent)", 51.054, 3.7217 ),
				new TownData(2, "Geel", 51.1658, 4.98609 ),
				new TownData(2, "Gembloux", 50.5613, 4.70153 ),
				new TownData(2, "Genappe", 50.6065, 4.45861 ),
				new TownData(2, "Genk", 50.967, 5.48989 ),
				new TownData(2, "Gistel", 51.1539, 2.93731 ),
				new TownData(2, "Grammontnew TownData(Geraardsbergen)", 50.7715, 3.88229 ),
				new TownData(2, "Halnew TownData(Halle)", 50.7368, 4.23711 ),
				new TownData(2, "Halen", 50.9541, 5.0907 ),
				new TownData(2, "Hamont-Achel", 51.2552, 5.49933 ),
				new TownData(2, "Hannut", 50.6574, 5.07474 ),
				new TownData(2, "Harelbeke", 50.8626, 3.30873 ),
				new TownData(2, "Hasselt", 50.9246, 5.31333 ),
				new TownData(2, "Herentals", 51.1595, 4.82911 ),
				new TownData(2, "Herve", 50.6491, 5.79597 ),
				new TownData(2, "Hoogstraten", 51.4404, 4.75861 ),
				new TownData(2, "Houffalize", 50.1488, 5.7737 ),
				new TownData(2, "Huy", 50.5032, 5.22641 ),
				new TownData(2, "Izegem", 50.9225, 3.20816 ),
				new TownData(2, "Jodoigne", 50.7256, 4.86104 ),
				new TownData(2, "La-Louvire", 50.4791, 4.14984 ),
				new TownData(2, "Landen", 50.749, 5.05229 ),
				new TownData(2, "La-Roche-en-Ardenne", 50.1603, 5.60172 ),
				new TownData(2, "Launew TownData(Zoutleeuw)", 50.8334, 5.10367 ),
				new TownData(2, "Le-Roeulx", 50.5049, 4.11283 ),
				new TownData(2, "Lessines", 50.7105, 3.82932 ),
				new TownData(2, "Leuze-en-Hainaut", 50.5968, 3.63213 ),
				new TownData(2, "Lige", 50.6225, 5.56944 ),
				new TownData(2, "Lierre", 51.139, 4.57389 ),
				new TownData(2, "Limbourg", 50.6148, 5.9408 ),
				new TownData(2, "Lokeren", 51.118, 3.96534 ),
				new TownData(2, "Lommel", 51.2167, 5.31584 ),
				new TownData(2, "Lo-Reninge", 50.9603, 2.77613 ),
				new TownData(2, "Louvainnew TownData(Leuven)", 50.8793, 4.70214 ),
				new TownData(2, "Maaseik", 51.0744, 5.72015 ),
				new TownData(2, "Malinesnew TownData(Mechelen)", 51.0289, 4.47807 ),
				new TownData(2, "Malmedy", 50.4345, 6.04173 ),
				new TownData(2, "Marche-en-Famenne", 50.2182, 5.33945 ),
				new TownData(2, "Meninnew TownData(Menen)", 50.7967, 3.11693 ),
				new TownData(2, "Messinesnew TownData(Mesen)", 50.764, 2.89877 ),
				new TownData(2, "Mons", 50.4458, 3.96991 ),
				new TownData(2, "Montaigu-Zichem", 51.0015, 4.98389 ),
				new TownData(2, "Mortsel", 51.1752, 4.4584 ),
				new TownData(2, "Mouscron", 50.7378, 3.25392 ),
				new TownData(2, "Namur", 50.4653, 4.86766 ),
				new TownData(2, "Neufchteau", 49.8412, 5.4223 ),
				new TownData(2, "Ninove", 50.8212, 3.99692 ),
				new TownData(2, "Nivelles", 50.5892, 4.32552 ),
				new TownData(2, "Ostendenew TownData(Oostende)", 51.2254, 2.91337 ),
				new TownData(2, "Ottignies-Louvain-la-Neuve", 50.6696, 4.61121 ),
				new TownData(2, "Oudenburg", 51.1843, 2.9972 ),
				new TownData(2, "Peer", 51.1222, 5.46872 ),
				new TownData(2, "Pruwelz", 50.5333, 3.56278 ),
				new TownData(2, "Philippeville", 50.1611, 4.60332 ),
				new TownData(2, "Poperinge", 50.8662, 2.70106 ),
				new TownData(2, "Renaixnew TownData(Ronse)", 50.745, 3.60227 ),
				new TownData(2, "Rochefort", 50.1657, 5.16967 ),
				new TownData(2, "Roulersnew TownData(Roeselare)", 50.9447, 3.12337 ),
				new TownData(2, "Saint-Ghislain", 50.4898, 3.80799 ),
				new TownData(2, "Saint-Hubert", 50.0379, 5.34486 ),
				new TownData(2, "Saint-Nicolasnew TownData(Sint-Niklaas)", 51.1646, 4.13922 ),
				new TownData(2, "Saint-Trondnew TownData(Sint-Truiden)", 50.8155, 5.18667 ),
				new TownData(2, "Seraing", 50.6033, 5.52139 ),
				new TownData(2, "Soignies", 50.5669, 4.04146 ),
				new TownData(2, "Stavelot", 50.4163, 5.9407 ),
				new TownData(2, "Termondenew TownData(Dendermonde)", 51.03, 4.09898 ),
				new TownData(2, "Thuin", 50.3218, 4.31078 ),
				new TownData(2, "Tielt", 51.0072, 3.36943 ),
				new TownData(2, "Tirlemontnew TownData(Tienen)", 50.8056, 4.93944 ),
				new TownData(2, "Tongresnew TownData(Tongeren)", 50.781, 5.46486 ),
				new TownData(2, "Torhout", 51.0588, 3.10152 ),
				new TownData(2, "Tournai", 50.6205, 3.41041 ),
				new TownData(2, "Turnhout", 51.329, 4.93672 ),
				new TownData(2, "Verviers", 50.5879, 5.8694 ),
				new TownData(2, "Vilvordenew TownData(Vilvoorde)", 50.9271, 4.42485 ),
				new TownData(2, "Virton", 49.5727, 5.57255 ),
				new TownData(2, "Vis", 50.7344, 5.69718 ),
				new TownData(2, "Walcourt", 50.2724, 4.41547 ),
				new TownData(2, "Waregem", 50.8797, 3.3983 ),
				new TownData(2, "Waremme", 50.6919, 5.26373 ),
				new TownData(2, "Wavre", 50.7232, 4.58798 ),
				new TownData(2, "Wervik", 50.812, 3.05278 ),
				new TownData(2, "Ypresnew TownData(Ieper)", 50.8513, 2.88419 ),
				new TownData(2, "Zottegem", 50.8642, 3.80691 ),

					new TownData(3, "Aix-en-Provence", 43.5249, 5.45414 ),
					new TownData(3, "Ajaccio", 50.4307, 2.93792 ),
					new TownData(3, "Albi", 43.9274, 2.14826 ),
					new TownData(3, "Als", 44.1274, 4.07903 ),
					new TownData(3, "Alfortville", 48.7988, 2.42344 ),
					new TownData(3, "Amiens", 49.8939, 2.29424 ),
					new TownData(3, "Angers", 47.4694, -0.549 ),
					new TownData(3, "Angoulme", 45.6483, 0.160924 ),
					new TownData(3, "Annecy", 45.8996, 6.12846 ),
					new TownData(3, "Antibes", 43.5807, 7.12087 ),
					new TownData(3, "Antony", 48.7537, 2.29711 ),
					new TownData(3, "Argenteuil", 48.9416, 2.24706 ),
					new TownData(3, "Arles", 43.6767, 4.6278 ),
					new TownData(3, "Arras", 50.2929, 2.7825 ),
					new TownData(3, "Asnires-sur-Seine", 48.9182, 2.28355 ),
					new TownData(3, "Aubagne", 43.2933, 5.57028 ),
					new TownData(3, "Aubervilliers", 48.9148, 2.38121 ),
					new TownData(3, "Aulnay-sous-Bois", 48.9402, 2.50225 ),
					new TownData(3, "Auxerre", 47.7983, 3.5744 ),
					new TownData(3, "Avignon", 43.9486, 4.80597 ),
					new TownData(3, "Bagneux", 48.7979, 2.3137 ),
					new TownData(3, "Bastia", 43.4773, -0.1262 ),
					new TownData(3, "Bayonne", 43.4934, -1.47454 ),
					new TownData(3, "Beauvais", 49.4293, 2.08107 ),
					new TownData(3, "Belfort", 47.6388, 6.86222 ),
					new TownData(3, "Besanon", 47.2412, 6.02557 ),
					new TownData(3, "Bziers", 43.3416, 3.21782 ),
					new TownData(3, "Blanc-Mesnil", 48.9383, 2.46049 ),
					new TownData(3, "Blois", 47.5859, 1.3301 ),
					new TownData(3, "Bobigny", 48.9064, 2.44049 ),
					new TownData(3, "Bondy", 48.9022, 2.48265 ),
					new TownData(3, "Bordeaux", 44.8374, -0.576144 ),
					new TownData(3, "Boulogne-Billancourt", 48.8338, 2.24344 ),
					new TownData(3, "Boulogne-sur-Mer", 50.7256, 1.61488 ),
					new TownData(3, "Bourg-en-Bresse", 46.2048, 5.2255 ),
					new TownData(3, "Bourges", 47.0829, 2.39658 ),
					new TownData(3, "Brest", 48.3906, -4.4869 ),
					new TownData(3, "Brive-la-Gaillarde", 45.1586, 1.53263 ),
					new TownData(3, "Bron", 45.7336, 4.90861 ),
					new TownData(3, "Caen", 49.1848, -0.360161 ),
					new TownData(3, "Cagnes-sur-Mer", 43.6625, 7.14948 ),
					new TownData(3, "Calais", 50.9579, 1.85214 ),
					new TownData(3, "Caluire-et-Cuire", 45.7963, 4.84238 ),
					new TownData(3, "Cannes", 43.5509, 7.01059 ),
					new TownData(3, "Cannet", 43.5762, 7.01958 ),
					new TownData(3, "Carcassonne", 43.2126, 2.3561 ),
					new TownData(3, "Castres", 43.6053, 2.24101 ),
					new TownData(3, "Cergy", 49.0525, 2.03883 ),
					new TownData(3, "Chlons-en-Champagne", 48.9552, 4.36364 ),
					new TownData(3, "Chalon-sur-Sane", 46.7842, 4.85295 ),
					new TownData(3, "Chambry", 45.5667, 5.92099 ),
					new TownData(3, "Champigny-sur-Marne", 48.8173, 2.49739 ),
					new TownData(3, "Charleville-Mzires", 49.7736, 4.72021 ),
					new TownData(3, "Chartres", 48.4444, 1.48417 ),
					new TownData(3, "Chteauroux", 46.8082, 1.69182 ),
					new TownData(3, "Chelles", 48.8807, 2.59384 ),
					new TownData(3, "Cholet", 47.0579, -0.879121 ),
					new TownData(3, "Clamart", 48.7991, 2.26248 ),
					new TownData(3, "Clermont-Ferrand", 45.7772, 3.08242 ),
					new TownData(3, "Clichy", 48.9027, 2.30408 ),
					new TownData(3, "Colmar", 48.0807, 7.35997 ),
					new TownData(3, "Colombes", 48.923, 2.255 ),
					new TownData(3, "Compigne", 49.4158, 2.82248 ),
					new TownData(3, "Corbeil-Essonnes", 48.6158, 2.4629 ),
					new TownData(3, "Courbevoie", 48.8968, 2.25652 ),
					new TownData(3, "Crteil", 48.7889, 2.45203 ),
					new TownData(3, "Dieppe", 49.9275, 1.08787 ),
					new TownData(3, "Dijon", 47.3272, 5.04399 ),
					new TownData(3, "Douai", 50.3675, 3.08249 ),
					new TownData(3, "Drancy", 48.9198, 2.45148 ),
					new TownData(3, "Dreux", 48.7383, 1.36113 ),
					new TownData(3, "Dunkerque", 51.0343, 2.37682 ),
					new TownData(3, "Epinal", 48.1748, 6.44998 ),
					new TownData(3, "Epinay-sur-Seine", 48.9532, 2.31272 ),
					new TownData(3, "Evreux", 49.0245, 1.15116 ),
					new TownData(3, "Evry", 48.6247, 2.43084 ),
					new TownData(3, "Fontenay-sous-Bois", 48.8512, 2.47434 ),
					new TownData(3, "Frjus", 43.4325, 6.73518 ),
					new TownData(3, "Gagny", 48.8828, 2.53487 ),
					new TownData(3, "Garges-ls-Gonesse", 48.9726, 2.38923 ),
					new TownData(3, "Gennevilliers", 48.9335, 2.29927 ),
					new TownData(3, "Grasse", 43.6586, 6.92355 ),
					new TownData(3, "Grenoble", 45.1943, 5.73161 ),
					new TownData(3, "Havre", 49.4926, 0.106503 ),
					new TownData(3, "Hyres", 43.1199, 6.12858 ),
					new TownData(3, "Issy-les-Moulineaux", 48.8231, 2.27338 ),
					new TownData(3, "Ivry-sur-Seine", 48.8078, 2.37467 ),
					new TownData(3, "Jou-ls-Tours", 47.3441, 0.660914 ),
					new TownData(3, "Laval", 48.0704, -0.773564 ),
					new TownData(3, "Levallois-Perret", 48.8943, 2.28834 ),
					new TownData(3, "Lille", 50.6372, 3.06302 ),
					new TownData(3, "Limoges", 45.8285, 1.26175 ),
					new TownData(3, "Livry-Gargan", 48.9165, 2.53159 ),
					new TownData(3, "Lorient", 47.7501, -3.36629 ),
					new TownData(3, "Lyon", 45.767299, 4.834329 ),
					new TownData(3, "Lyon", 45.7578, 4.8351 ),
					new TownData(3, "Mcon", 46.3063, 4.82919 ),
					new TownData(3, "Maisons-Alfort", 48.8057, 2.44086 ),
					new TownData(3, "Mans", 47.8692, -0.128695 ),
					new TownData(3, "Mantes-la-Jolie", 48.9904, 1.71936 ),
					new TownData(3, "Marcq-en-Baroeul", 50.6655, 3.10447 ),
					new TownData(3, "Marseille", 43.353, 5.42767 ),
					new TownData(3, "Martigues", 43.4074, 5.05484 ),
					new TownData(3, "Massy", 48.7303, 2.27287 ),
					new TownData(3, "Meaux", 48.9577, 2.88182 ),
					new TownData(3, "Melun", 48.5415, 2.66029 ),
					new TownData(3, "Mrignac", 44.8418, -0.647795 ),
					new TownData(3, "Metz", 49.1161, 6.1727 ),
					new TownData(3, "Meudon", 48.8122, 2.23831 ),
					new TownData(3, "Montauban", 44.0176, 1.35891 ),
					new TownData(3, "Montluon", 46.3424, 2.60757 ),
					new TownData(3, "Montpellier", 43.6085, 3.87921 ),
					new TownData(3, "Montreuil", 48.8582, 2.43687 ),
					new TownData(3, "Montrouge", 48.8185, 2.31993 ),
					new TownData(3, "Mulhouse", 47.7495, 7.33978 ),
					new TownData(3, "Nancy", 48.6908, 6.1825 ),
					new TownData(3, "Nanterre", 48.89, 2.19705 ),
					new TownData(3, "Nantes", 47.2168, -1.55674 ),
					new TownData(3, "Narbonne", 43.1836, 3.00419 ),
					new TownData(3, "Neuilly-sur-Seine", 48.8836, 2.27251 ),
					new TownData(3, "Nevers", 46.9872, 3.16184 ),
					new TownData(3, "Nice", 43.7034, 7.2662 ),
					new TownData(3, "Nmes", 43.8346, 4.36086 ),
					new TownData(3, "Niort", 46.3239, -0.457584 ),
					new TownData(3, "Noisy-le-Grand", 48.8478, 2.55281 ),
					new TownData(3, "Noisy-le-Sec", 48.8901, 2.45287 ),
					new TownData(3, "Orlans", 47.9014, 1.90398 ),
					new TownData(3, "Pantin", 48.8931, 2.41272 ),
					new TownData(3, "Paris", 48.8589, 2.347 ),
					new TownData(3, "Pau", 43.2975, -0.374362 ),
					new TownData(3, "Perpignan", 42.7016, 2.89415 ),
					new TownData(3, "Pessac", 44.8037, -0.631678 ),
					new TownData(3, "Poissy", 48.9286, 2.0418 ),
					new TownData(3, "Poitiers", 46.587, 0.342648 ),
					new TownData(3, "Puteaux", 48.8833, 2.23768 ),
					new TownData(3, "Quimper", 47.9959, -4.09978 ),
					new TownData(3, "Reims", 49.2566, 4.03309 ),
					new TownData(3, "Rennes", 48.1118, -1.68026 ),
					new TownData(3, "Roanne", 46.0392, 4.07187 ),
					new TownData(3, "Rochelle", 46.1581, -1.15364 ),
					new TownData(3, "Roche-sur-Yon", 46.6694, -1.41872 ),
					new TownData(3, "Rosny-sous-Bois", 48.8743, 2.48255 ),
					new TownData(3, "Roubaix", 50.6913, 3.1732 ),
					new TownData(3, "Rouen", 49.4424, 1.09849 ),
					new TownData(3, "Rueil-Malmaison", 48.8774, 2.17913 ),
					new TownData(3, "Sarcelles", 48.9963, 2.37946 ),
					new TownData(3, "Sartrouville", 48.9458, 2.17228 ),
					new TownData(3, "Ste", 43.4017, 3.69661 ),
					new TownData(3, "Sevran", 48.9379, 2.52977 ),
					new TownData(3, "Seyne-sur-Mer", 43.0945, 5.88286 ),
					new TownData(3, "St-Brieuc", 48.5138, -2.76264 ),
					new TownData(3, "St-Chamond", 45.4832, 4.51029 ),
					new TownData(3, "St-Denis", 48.9361, 2.36488 ),
					new TownData(3, "St-Etienne", 45.4396, 4.38783 ),
					new TownData(3, "St-Germain-en-Laye", 48.8987, 2.0936 ),
					new TownData(3, "St-Herblain", 47.2144, -1.63888 ),
					new TownData(3, "St-Malo", 48.6482, -2.02609 ),
					new TownData(3, "St-Maur-des-Fosss", 48.7979, 2.50296 ),
					new TownData(3, "St-Nazaire", 47.2743, -2.21361 ),
					new TownData(3, "St-Ouen", 48.9061, 2.33183 ),
					new TownData(3, "St-Priest", 45.6942, 4.93504 ),
					new TownData(3, "St-Quentin", 49.8482, 3.28822 ),
					new TownData(3, "Strasbourg", 48.5829, 7.74375 ),
					new TownData(3, "Suresnes", 48.8701, 2.22214 ),
					new TownData(3, "Tarbes", 43.2329, 0.074121 ),
					new TownData(3, "Thionville", 49.3571, 6.16845 ),
					new TownData(3, "Toulon", 43.1252, 5.93111 ),
					new TownData(3, "Toulouse", 43.6044, 1.44295 ),
					new TownData(3, "Tourcoing", 50.7225, 3.15954 ),
					new TownData(3, "Tours", 47.3903, 0.688851 ),
					new TownData(3, "Troyes", 48.2975, 4.0748 ),
					new TownData(3, "Valence", 44.9305, 4.89025 ),
					new TownData(3, "Valenciennes", 50.3576, 3.52349 ),
					new TownData(3, "Vannes", 47.6547, -2.75951 ),
					new TownData(3, "Vaulx-en-Velin", 45.7776, 4.9188 ),
					new TownData(3, "Vnissieux", 45.6964, 4.88381 ),
					new TownData(3, "Versailles", 48.8023, 2.12982 ),
					new TownData(3, "Villejuif", 48.7951, 2.36653 ),
					new TownData(3, "Villeneuve-d'Ascq", 50.6207, 3.1315 ),
					new TownData(3, "Villeurbanne", 45.7648, 4.88037 ),
					new TownData(3, "Vincennes", 48.845, 2.43459 ),
					new TownData(3, "Vitrolles", 43.4604, 5.24853 ),
					new TownData(3, "Vitry-sur-Seine", 48.7894, 2.38932 ),
					new TownData(3, "Wattrelos", 50.7013, 3.21565 ),

				new TownData(4, "Differdange", 49.5223, 5.93568 ),
				new TownData(4, "Wiltz", 49.8297, 5.96536 ),
				new TownData(4, "Rumelange", 49.4965, 5.98512 ),
				new TownData(4, "Esch-sur-Alzette", 49.4963, 5.98527 ),
				new TownData(4, "Dudelange", 49.5175, 6.09443 ),
				new TownData(4, "Ettelbruck", 49.8478, 6.10285 ),
				new TownData(4, "Luxembourg", 49.6001, 6.13412 ),
				new TownData(4, "Diekirch", 49.8655, 6.15811 ),
				new TownData(4, "Vianden", 49.9317, 6.20554 ),
				new TownData(4, "Remich", 49.5463, 6.36018 ),
				new TownData(4, "Grevenmacher", 49.6788, 6.40065 ),
				new TownData(4, "Echternach", 49.8123, 6.41943 ),

				new TownData(5, "Agadir     ", 30.4144, -9.59650 ),
				new TownData(5, "At Baha   ", 30.0715, -9.16164 ),
				new TownData(5, "At Melloul", 30.3218, -9.51406 ),
				new TownData(5, "Al Hoceima ", 35.2493, -3.93711 ),
				new TownData(5, "Azilal     ", 31.9669, -6.56620 ),
				new TownData(5, "Ben Slimane", 33.6233, -7.12064 ),
				new TownData(5, "Beni Mellal", 32.3502, -6.35879 ),
				new TownData(5, "Berkane    ", 34.9227, -2.32735 ),
				new TownData(5, "Boulemane  ", 30.3667, -7.93333 ),
				new TownData(5, "Casablanca ", 33.5889, -7.60890 ),
				new TownData(5, "Chichaoua  ", 31.5465, -8.76260 ),
				new TownData(5, "El Hajeb   ", 33.6981, -5.36479 ),
				new TownData(5, "El Jadida  ", 33.2559, -8.50783 ),
				new TownData(5, "Essaouira  ", 31.4984, -9.76200 ),
				new TownData(5, "Fs        ", 34.0469, -4.99630 ),
				new TownData(5, "Figuig     ", 32.1010, -1.22140 ),
				new TownData(5, "Guelmim    ", 28.9816, -10.0599 ),
				new TownData(5, "Ifrane     ", 34.0500, -3.76667 ),
				new TownData(5, "Jerada     ", 34.3100, -2.16080 ),
				new TownData(5, "Knitra    ", 34.2729, -6.57600 ),
				new TownData(5, "Khmisset  ", 33.8238, -6.06360 ),
				new TownData(5, "Khenifra   ", 32.9386, -5.66820 ),
				new TownData(5, "Khouribga  ", 32.8810, -6.91110 ),
				new TownData(5, "Larache    ", 35.1918, -6.15360 ),
				new TownData(5, "Marrakech  ", 31.6373, -8.01750 ),
				new TownData(5, "Mekns     ", 33.8951, -5.55500 ),
				new TownData(5, "Nador      ", 33.6167, -3.73333 ),
				new TownData(5, "Ouarzazate ", 30.9188, -6.89750 ),
				new TownData(5, "Oujda      ", 34.6943, -1.91830 ),
				new TownData(5, "Rabat      ", 33.9905, -6.87040 ),
				new TownData(5, "Safi       ", 32.2977, -9.23470 ),
				new TownData(5, "Sefrou     ", 33.8264, -4.83470 ),
				new TownData(5, "Settat     ", 33.0062, -7.61930 ),
				new TownData(5, "Tan-Tan    ", 28.4357, -11.1017 ),
				new TownData(5, "Tanger     ", 35.7728, -5.82350 ),
				new TownData(5, "Taounate   ", 34.5358, -4.64010 ),
				new TownData(5, "Tata       ", 29.7428, -7.97260 ),
				new TownData(5, "Taza       ", 34.2234, -4.00690 ),
				new TownData(5, "Ttouan    ", 35.5720, -5.37230 ),
				new TownData(5, "Tiznit     ", 29.6922, -9.72380 ),
																																																													
																																																													
				new TownData(6, "An Draham    ", 36.780000, 8.687240  ),
				new TownData(6, "Bja          ", 36.727200, 9.188200  ),
				new TownData(6, "Ben Arous     ", 36.749700, 10.320600 ),
				new TownData(6, "Ben Gardane   ", 33.137900, 11.224400 ),
				new TownData(6, "Bizerte       ", 37.272000, 9.870800  ),
				new TownData(6, "Bou Arada     ", 36.351000, 9.624500  ),
				new TownData(6, "Bou Merdes    ", 35.460100, 10.727000 ),
				new TownData(6, "Chebba        ", 35.238900, 11.114800 ),
				new TownData(6, "Chorbane      ", 35.283500, 10.385100 ),
				new TownData(6, "Douz          ", 33.459600, 9.024050  ),
				new TownData(6, "El An        ", 35.480000, 8.310000  ),
				new TownData(6, "El Alia       ", 37.174900, 10.032200 ),
				new TownData(6, "El Aroussa    ", 36.378700, 9.450640  ),
				new TownData(6, "El Hamma      ", 33.884100, 9.791840  ),
				new TownData(6, "El Haouaria   ", 37.054900, 11.013100 ),
				new TownData(6, "El Ksour      ", 35.924200, 9.330560  ),
				new TownData(6, "Gafour       ", 36.321900, 9.320400  ),
				new TownData(6, "Gabs         ", 33.884200, 10.092600 ),
				new TownData(6, "Gafsa         ", 34.419300, 8.784600  ),
				new TownData(6, "Ghardimaou    ", 36.449300, 8.436420  ),
				new TownData(6, "Ghomrassen    ", 33.057600, 10.335300 ),
				new TownData(6, "Goubellat     ", 36.538500, 9.660700  ),
				new TownData(6, "Graba        ", 34.496400, 10.212600 ),
				new TownData(6, "Grombalia     ", 36.600000, 10.501300 ),
				new TownData(6, "Hadra        ", 35.564500, 8.454800  ),
				new TownData(6, "Hammam Sousse ", 35.856900, 10.597200 ),
				new TownData(6, "Hammamet      ", 36.400700, 10.617000 ),
				new TownData(6, "Hencha        ", 35.120600, 10.739200 ),
				new TownData(6, "Hergla        ", 36.030100, 10.507900 ),
				new TownData(6, "Jemmal        ", 35.630600, 10.757000 ),
				new TownData(6, "Jendouba      ", 36.495900, 8.776800  ),
				new TownData(6, "Jrissa       ", 35.843500, 8.641700  ),
				new TownData(6, "Kairouan      ", 35.677600, 10.092400 ),
				new TownData(6, "Kalaa Kebira  ", 35.869200, 10.532900 ),
				new TownData(6, "Kasserine     ", 35.167400, 8.836900  ),
				new TownData(6, "Kbili        ", 33.703900, 8.967600  ),
				new TownData(6, "Klibia       ", 36.846200, 11.093700 ),
				new TownData(6, "Khniss        ", 35.715200, 10.815700 ),
				new TownData(6, "La Marsa      ", 36.884700, 10.333600 ),
				new TownData(6, "Le Kef        ", 36.180400, 8.706000  ),
				new TownData(6, "Mahdia        ", 35.504400, 11.066100 ),
				new TownData(6, "Makthar       ", 35.856700, 9.205000  ),
				new TownData(6, "Manouba       ", 36.798000, 10.105500 ),
				new TownData(6, "Matmata       ", 33.545700, 9.968600  ),
				new TownData(6, "Mdenine      ", 33.346100, 10.489500 ),
				new TownData(6, "Meknassy      ", 34.602700, 9.601800  ),
				new TownData(6, "Menzel Bouzelfa", 36.681400, 10.584900 ),
				new TownData(6, "Mtlaoui      ", 34.315300, 8.404600  ),
				new TownData(6, "Metline       ", 37.262800, 10.063700 ),
				new TownData(6, "Mtouia       ", 33.962700, 9.997860  ),
				new TownData(6, "Mezzouna      ", 34.575900, 9.843600  ),
				new TownData(6, "Moknine       ", 35.627600, 10.900800 ),
				new TownData(6, "Monastir      ", 35.767800, 10.822500 ),
				new TownData(6, "Mornag        ", 36.685100, 10.286400 ),
				new TownData(6, "Nabeul        ", 36.454100, 10.735400 ),
				new TownData(6, "Nefta         ", 33.870700, 7.877600  ),
				new TownData(6, "Oued Ellil    ", 36.836500, 10.041100 ),
				new TownData(6, "Raf Raf       ", 37.195100, 10.183300 ),
				new TownData(6, "Redeyef       ", 34.385700, 8.155100  ),
				new TownData(6, "Remada        ", 32.317900, 10.397300 ),
				new TownData(6, "Sbetla       ", 35.231000, 9.134800  ),
				new TownData(6, "Sers          ", 36.078100, 9.021060  ),
				new TownData(6, "Sfax          ", 34.739100, 10.758800 ),
				new TownData(6, "Sidi Bou Ali  ", 35.954800, 10.467300 ),
				new TownData(6, "Sidi Bouzid   ", 35.039300, 9.492050  ),
				new TownData(6, "Siliana       ", 36.082100, 9.374800  ),
				new TownData(6, "Soliman       ", 36.692700, 10.491800 ),
				new TownData(6, "Sounine       ", 37.210200, 10.169500 ),
				new TownData(6, "Tabarka       ", 36.953100, 8.754550  ),
				new TownData(6, "Tajerouine    ", 35.900000, 8.550000  ),
				new TownData(6, "Tamerza       ", 34.388300, 7.943500  ),
				new TownData(6, "Tebourba      ", 36.881700, 9.797990  ),
				new TownData(6, "Thala         ", 35.572400, 8.669200  ),
				new TownData(6, "Thlepte      ", 34.979500, 8.599700  ),
				new TownData(6, "Tozeur        ", 33.922300, 8.138900  ),
				new TownData(6, "Tunis         ", 36.789900, 10.210000 ),
				new TownData(6, "Zaghouan      ", 36.399800, 10.144800 ),
				new TownData(6, "Zarat         ", 33.666700, 10.350000 ),
				new TownData(6, "Zarzis        ", 33.504300, 11.111800 ),
				new TownData(6, "Zramdine     ", 35.576600, 10.729800 ),


				new TownData(7, "Adliswil         ", 47.313600, 8.527750 ),
				new TownData(7, "Affoltern am Albis", 47.278200, 8.454500 ),
				new TownData(7, "Allschwil        ", 47.552500, 7.544960 ),
				new TownData(7, "Altsttten       ", 47.377600, 9.546820 ),
				new TownData(7, "Amriswil         ", 47.545800, 9.300940 ),
				new TownData(7, "Arbon            ", 47.515000, 9.432170 ),
				new TownData(7, "Arth             ", 47.062300, 8.523120 ),
				new TownData(7, "Baar             ", 47.195000, 8.523170 ),
				new TownData(7, "Baden            ", 47.473100, 8.309100 ),
				new TownData(7, "Ble             ", 47.368200, 7.353060 ),
				new TownData(7, "Bellinzone       ", 46.193300, 9.018020 ),
				new TownData(7, "Berne            ", 46.575000, 6.723340 ),
				new TownData(7, "Berthoud         ", 46.902700, 6.585510 ),
				new TownData(7, "Bienne           ", 47.065200, 7.101190 ),
				new TownData(7, "Binningen        ", 47.541800, 7.574490 ),
				new TownData(7, "Birsfelden       ", 47.553300, 7.622080 ),
				new TownData(7, "Brigue-Glis      ", 46.310600, 7.976870 ),
				new TownData(7, "Buchs SG         ", 47.165600, 9.470790 ),
				new TownData(7, "Bulle            ", 46.618000, 7.057030 ),
				new TownData(7, "Blach           ", 47.517400, 8.541190 ),
				new TownData(7, "Carouge          ", 46.183400, 6.137460 ),
				new TownData(7, "Cham             ", 47.182200, 8.460890 ),
				new TownData(7, "Chne-Bougeries  ", 46.198300, 6.185570 ),
				new TownData(7, "Coire            ", 47.274700, 7.400250 ),
				new TownData(7, "Davos            ", 46.621800, 9.575160 ),
				new TownData(7, "Delmont         ", 47.529400, 7.622600 ),
				new TownData(7, "Dietikon         ", 47.402700, 8.400950 ),
				new TownData(7, "Dbendorf        ", 47.396900, 8.619970 ),
				new TownData(7, "Ebikon           ", 47.084600, 8.342450 ),
				new TownData(7, "Ecublens VD      ", 46.534500, 6.566040 ),
				new TownData(7, "Einsiedeln       ", 47.173300, 8.772700 ),
				new TownData(7, "Emmen            ", 47.078400, 8.277660 ),
				new TownData(7, "Frauenfeld       ", 47.555400, 8.896970 ),
				new TownData(7, "Freienbach       ", 47.309900, 9.528990 ),
				new TownData(7, "Fribourg         ", 46.803500, 7.151170 ),
				new TownData(7, "Genve           ", 46.203809, 6.139958 ),
				new TownData(7, "Gland            ", 46.726800, 7.561560 ),
				new TownData(7, "Gossau SG        ", 47.414100, 9.252010 ),
				new TownData(7, "Granges SO       ", 46.793000, 7.159840 ),
				new TownData(7, "Herisau          ", 47.385100, 9.278020 ),
				new TownData(7, "Horgen           ", 47.260800, 8.597670 ),
				new TownData(7, "Horw             ", 47.017700, 8.306850 ),
				new TownData(7, "Illnau-Effretikon", 47.427800, 8.685740 ),
				new TownData(7, "Ittigen          ", 46.973400, 7.484200 ),
				new TownData(7, "Kloten           ", 47.451300, 8.582780 ),
				new TownData(7, "Kreuzlingen      ", 47.649000, 9.174800 ),
				new TownData(7, "Kriens           ", 47.034000, 8.282200 ),
				new TownData(7, "Ksnacht ZH      ", 47.319500, 8.580610 ),
				new TownData(7, "Kssnacht am Rigi", 47.084000, 8.434010 ),
				new TownData(7, "Kniz            ", 46.926300, 7.417170 ),
				new TownData(7, "La Chaux-de-Fonds", 47.103100, 6.832650 ),
				new TownData(7, "La Tour-de-Peilz ", 46.454800, 6.858770 ),
				new TownData(7, "Lancy            ", 46.184000, 6.122630 ),
				new TownData(7, "Langenthal       ", 47.294800, 8.083050 ),
				new TownData(7, "Lausanne         ", 46.521900, 6.634660 ),
				new TownData(7, "Le Grand-Saconnex", 46.235700, 6.126220 ),
				new TownData(7, "Le Locle         ", 47.055700, 6.745650 ),
				new TownData(7, "Liestal          ", 47.483900, 7.734600 ),
				new TownData(7, "Littau           ", 47.064000, 8.280320 ),
				new TownData(7, "Locarno          ", 46.163400, 8.802140 ),
				new TownData(7, "Lucerne          ", 46.392500, 6.804080 ),
				new TownData(7, "Lugano           ", 46.005900, 8.946460 ),
				new TownData(7, "Lyss             ", 47.073700, 7.305800 ),
				new TownData(7, "Martigny         ", 46.105900, 7.079150 ),
				new TownData(7, "Meilen           ", 47.269800, 8.644090 ),
				new TownData(7, "Meyrin           ", 46.232400, 6.081900 ),
				new TownData(7, "Monthey          ", 46.251500, 6.945630 ),
				new TownData(7, "Montreux         ", 46.430800, 6.914220 ),
				new TownData(7, "Morges           ", 46.510800, 6.500040 ),
				new TownData(7, "Muri bei Bern    ", 46.931200, 7.485690 ),
				new TownData(7, "Muttenz          ", 47.523000, 7.645460 ),
				new TownData(7, "Mnchenstein     ", 47.513400, 7.617510 ),
				new TownData(7, "Mnsingen        ", 46.873500, 7.559780 ),
				new TownData(7, "Neuchtel        ", 46.991100, 6.929980 ),
				new TownData(7, "Nyon             ", 46.382300, 6.239840 ),
				new TownData(7, "Oberwil BL       ", 47.515600, 7.559130 ),
				new TownData(7, "Oftringen        ", 47.312200, 7.926970 ),
				new TownData(7, "Olten            ", 47.350800, 7.901220 ),
				new TownData(7, "Onex             ", 46.181600, 6.101600 ),
				new TownData(7, "Opfikon          ", 47.428200, 8.574190 ),
				new TownData(7, "Ostermundigen    ", 46.957800, 7.496740 ),
				new TownData(7, "Pratteln         ", 47.522600, 7.691150 ),
				new TownData(7, "Prilly           ", 46.534200, 6.606150 ),
				new TownData(7, "Pully            ", 46.510800, 6.659520 ),
				new TownData(7, "Rapperswil-Jona  ", 47.230100, 8.837360 ),
				new TownData(7, "Regensdorf       ", 47.433900, 8.468920 ),
				new TownData(7, "Reinach BL       ", 47.493400, 7.590730 ),
				new TownData(7, "Renens           ", 46.547300, 6.564900 ),
				new TownData(7, "Rheinfelden      ", 47.551000, 7.791670 ),
				new TownData(7, "Richterswil      ", 47.209600, 8.705390 ),
				new TownData(7, "Riehen           ", 47.584600, 7.650970 ),
				new TownData(7, "Rti ZH          ", 47.258600, 8.851250 ),
				new TownData(7, "Saint-Gall       ", 47.426500, 9.376050 ),
				new TownData(7, "Schaffhouse      ", 47.697500, 8.632230 ),
				new TownData(7, "Schlieren        ", 47.395800, 8.447060 ),
				new TownData(7, "Schwytz          ", 47.021000, 8.653510 ),
				new TownData(7, "Sierre           ", 46.292200, 7.531930 ),
				new TownData(7, "Sion             ", 46.227300, 7.358990 ),
				new TownData(7, "Soleure          ", 47.160800, 7.280720 ),
				new TownData(7, "Spiez            ", 46.688200, 7.678340 ),
				new TownData(7, "Spreitenbach     ", 47.418900, 8.362910 ),
				new TownData(7, "Steffisburg      ", 46.772800, 7.615170 ),
				new TownData(7, "Stfa            ", 47.240400, 8.721730 ),
				new TownData(7, "Thalwil          ", 47.292100, 8.564970 ),
				new TownData(7, "Thnex           ", 46.192800, 6.203640 ),
				new TownData(7, "Thoune           ", 46.752600, 7.623340 ),
				new TownData(7, "Uster            ", 47.350400, 8.718450 ),
				new TownData(7, "Uzwil            ", 47.437800, 9.132550 ),
				new TownData(7, "Vernier          ", 46.215000, 6.084140 ),
				new TownData(7, "Versoix          ", 46.280100, 6.166180 ),
				new TownData(7, "Vevey            ", 46.463000, 6.843430 ),
				new TownData(7, "Villars-sur-Glne", 46.792600, 7.132490 ),
				new TownData(7, "Volketswil       ", 47.389700, 8.690170 ),
				new TownData(7, "Wallisellen      ", 47.412900, 8.593440 ),
				new TownData(7, "Wettingen        ", 47.464400, 8.324840 ),
				new TownData(7, "Wetzikon ZH      ", 47.334100, 8.815630 ),
				new TownData(7, "Wil SG           ", 47.467100, 9.048950 ),
				new TownData(7, "Winterthour      ", 47.499900, 8.726160 ),
				new TownData(7, "Wohlen           ", 47.352200, 8.277250 ),
				new TownData(7, "Worb             ", 46.930100, 7.563330 ),
				new TownData(7, "Wdenswil        ", 47.230400, 8.671200 ),
				new TownData(7, "Yverdon-les-Bains", 46.781400, 6.640840 ),
				new TownData(7, "Zofingue         ", 47.285600, 7.947600 ),
				new TownData(7, "Zollikon         ", 47.337500, 8.569660 ),
				new TownData(7, "Zoug             ", 47.166200, 8.515410 ),
				new TownData(7, "Zurich           ", 47.400700, 8.499040 ),

		};
	}
	

//---------------------------------------------------------------------------
// Algorithms from 	http://www.jgiesen.de/SME/details/basics/meeus.htm#solar
//								 	http://www.jgiesen.de/SME/details/basics/index.htm
//  								http://stjarnhimlen.se/comp/riset.html#3
//									http://www.ummah.net/astronomy/saltime/
// modified by Lotfi BAGHLI on 15/01/2006, 10/06/2006, java 15/06/2007
//---------------------------------------------------------------------------
	public mainroutines( SalatTimeCanvas cvs)	{
		int i;
		canvas=cvs;
		validSalatTimeC=false;
		limitValid=false;
		SalatTimeConfig=new SalatTimeConfigStruct[NConvention];
		for ( i=0; i<NConvention; i++)
			SalatTimeConfig[i]=new SalatTimeConfigStruct();
// NTowns fix en statique, lecture des donnnes ds ReadConfigFile
//		Towns=new TownData [NTowns];
		Countries=new CountryData [NCountries];
//		 for ( i=0; i<NTowns; i++)
//				Towns[i]=new TownData();
		 for ( i=0; i<NCountries; i++)
			 Countries[i]=new CountryData();
		System.out.println("debug constructeur alloc SalatTimeConfig et Towns ok");
		Soleil=new Astre();
		SalatTime=new SalatTimeStruct();
		SalatTimeC=new SalatTimeStruct();
		date=new DateUT();
		LastComputeDate=new DateUT();
		heure=new Heure();
		calendarNow = Calendar.getInstance();
		System.out.println("debug constructeur alloc SalatTime, date, heure ok");
		Alarme_Fajr=0; Alarme_Zuhr=0; Alarme_Asr=0; Alarme_Maghrib=0; Alarme_Isha=0;
		}

// Julian day: 86400 s, Julian year: 365.25 d, Julian Century: 36525 d
// Julian Day (valid from 1900/3/1 to 2100/2/28)
  double JulianDay (int date, int month, int year, double UT)
	{
	if (month<=2) {month=month+12; year=year-1;}
	return (int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0;
	}
//---------------------------------------------------------------------------
// Julian century depuis 01/01/2000  12h UT
  double JulianCentury (int date, int month, int year, double UT)
	{
	if (month<=2) {month=month+12; year=year-1;}
  return ((int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0 - 2451545.0)/36525;
	} 
//---------------------------------------------------------------------------
//Solar Coordinates (according to: Jean Meeus: Astronomical Algorithms), accuracy of 0.01 degree 
double SoleilLongitude( double T)   // L
{
double M, L0, DL, L, Lm;
	M = 357.52910 + 35999.05030*T - 0.0001559*T*T - 0.00000048*T*T*T; // mean anomaly, degree
	L0 = 280.46645 + 36000.76983*T + 0.0003032*T*T; // mean longitude, degree 
	DL = (1.914600 - 0.004817*T - 0.000014*T*T)*Math.sin(deg2rd*M)
				+ (0.019993 - 0.000101*T)*Math.sin(deg2rd*2*M) + 0.000290*Math.sin(deg2rd*3*M); 
	L=L0 + DL; // true longitude, deg sans modulo
	Lm=L-360*(int)(L/360);
	if (Lm<0)	Lm+=360;
	return Lm*deg2rd; // true longitude, rd 
}
//---------------------------------------------------------------------------
// convert ecliptic longitude L (rd) to right ascension RA and declination delta
void eclipticL2RA_delta() // Soleil.L, & Soleil.RA, & Soleil.delta
{
double eps, X, Y, Z, R;
  eps = deg2rd*23.43999; // obliquity of ecliptic
	X = Math.cos(Soleil.L); Y = Math.cos(eps)*Math.sin(Soleil.L); Z = Math.sin(eps)*Math.sin(Soleil.L); R = Math.sqrt(1.0-Z*Z); 
	Soleil.delta = mMath.atan2(Z, R); // in rd 
	Soleil.RA = 2*mMath.atan2(Y, X+R); //  in rd 
}
//---------------------------------------------------------------------------
//compute sidereal time at Greenwich (according to: Jean Meeus: Astronomical Algorithms ) 
double TempsSideral( double T)   // theta0
{
	double theta0, theta0m;
//	T siecle julien depuis 2000
	theta0=280.46061837 + 360.98564736629*T*36525 + 0.000387933*T*T - T*T*T/38710000.0;
	theta0m=theta0-360*(int)(theta0/360);
	if (theta0m<0)	theta0m+=360;
	return theta0m*deg2rd;    // TempsSideralen rd
}
//---------------------------------------------------------------------------
//convert tau, delta to horizon coordinates of the observer (altitude h, azimuth az) , needs latitude : beta
void equatorial2horizontal()	// latitude, Soleil.tau, Soleil.delta, & Soleil.h, & Soleil.az);
{
	Soleil.h=mMath.asin( Math.sin(latitude)*Math.sin(Soleil.delta) + Math.cos(latitude)*Math.cos(Soleil.delta)*Math.cos(Soleil.tau));	// h en rd
	Soleil.az =mMath.atan2( -Math.sin(Soleil.tau), Math.cos(latitude)*Math.tan(Soleil.delta) - Math.sin(latitude)*Math.cos(Soleil.tau))-M_PI;	// az en rd du SUD
	if (Soleil.az<0)	Soleil.az+=2*M_PI;
}
//---------------------------------------------------------------------------
// check DST applies ou non
boolean CalcTimeZone( int a, int m, int j, int DST, int TimeZoneTown)
{      // ici on approxime TimeZoneTown avec MyTimeZone puisque a n'a pas d'importance
int jjdebut, jjfin, mmdebut, mmfin, ji, jour, JourToSwitch;
	jjdebut=0; jjfin=0;
double T;
	if (DST==2) {JourToSwitch=4; mmdebut=4; mmfin=9;} // dernier vendredi d'avril / septembre
			else		{JourToSwitch=6; mmdebut=3; mmfin=10;}// dernier dimanche de mars / octobre
// recherchedernier dimanche de mars et dernier dimanche d'octobre
// DST applys 26-Mar, 02:00h    29-Oct, 03:00h   pour 2006
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmdebut, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjdebut=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmfin, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjfin=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	if (m>mmdebut && m<mmfin)	return true;
	if (m==mmdebut && j>=jjdebut)	return true;
	if (m==mmfin && j<jjfin)	return true;
	return false;
}

//---------------------------------------------------------------------------
//convert rad en deg min sec
String rd2degminsec( double angle)
{
double h, m, s;
StringBuffer SS;
int hi, mi;
	h=angle*rd2deg;
	hi=(int)h;
	m=(h-hi)*60;
	mi=(int)((h-hi)*60);
	s=(m-mi)*60;
//	sprintf (SS,"%3d%02d'%02.0f\"", hi, mi,s);
	SS=new StringBuffer();
	SS.append(hi);
	SS.append("");
	SS.append(mi);
	SS.append("'");
	SS.append(s);
	SS.append("\"");
	return SS.toString();
}
//---------------------------------------------------------------------------
//convert rad en deg min 
String rd2degmin( double angle)
{
double h;
StringBuffer SS;
int hi, mi;
	h=angle*rd2deg;
	hi=(int)h;
	mi=(int)((h-hi)*60);
//	sprintf (SS,"%3d%02d'%02.0f\"", hi, mi,s);
	SS=new StringBuffer();
	SS.append(hi);
	SS.append("");
	SS.append(mi);
	SS.append("'");
	return SS.toString();
}
//---------------------------------------------------------------------------
//convert rad en h min sec
String rd2hminsec( double angle)
{
double h, m, s;
int hi, mi;
	h=rd2heure*angle;
	hi=(int)h;
	m=(h-hi)*60;
	mi=(int)((h-hi)*60);
	s=(m-mi)*60;
	String SS=hi+"h"+mi+"'"+s+"\"";//"%02dh%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert h en h min sec
String h2hminsec( double h)
{
double m, s;
int hi, mi;
	hi=(int)h;
	m=(h-hi)*60;
	mi=(int)((h-hi)*60);
	s=(m-mi)*60;
//	sprintf (SS,"%02dh%02d'%02.0f\"", hi, mi,s);
	String SS=hi+"h"+mi+"'"+s+"\"";
	return SS;
}
//---------------------------------------------------------------------------
//convert h en h min arondie
String h2hmiarrondie( double h)
{
double m, s;
int hi, mi;
	hi=(int)h;
	m=(h-hi)*60;
	mi=(int)((h-hi)*60);
	s=(m-mi)*60;
	if (s>=30)	{
				mi++;
				if (mi==60)	{
							mi=0; hi++;
							if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
										//sprintf(SS, "erreur : arrondi au jour suivant");
										String SS="erreur : arrondi au jour suivant";
										return SS;
						                }	
							}
							}
//	sprintf(SS, "%02d:%02d",hi,mi);
//	String SS=hi+":"+mi;
//	String SS=String.format("%02d:%02d",hi,mi);
	String SS="";
	if (hi<10) SS+="0";
	SS+=hi+":";
	if (mi<10) SS+="0";
	SS+=mi;
	
	return SS;
}
//---------------------------------------------------------------------------
//Rcupre la date
void GetDate()
{
//	System.out.println("La date d'observation _actuelle_ (d/m/a)");
	calendarNow.setTime(new Date(System.currentTimeMillis()));
	date.j=calendarNow.get(Calendar.DATE);	
	date.m=calendarNow.get(Calendar.MONTH)+1;
	date.a=calendarNow.get(Calendar.YEAR);
//	String SS="Date dtermine : "+date.j+"/"+date.m+"/"+date.a;
//	System.out.println(SS);
}
//---------------------------------------------------------------------------
//Rcupre l'heure
void GetHeure()
{
//	System.out.println("L'heure d'observation _actuelle_ (h/m/s)");
	calendarNow.setTime(new Date(System.currentTimeMillis()));
////	TimeZone tz = TimeZone.getDefault();
//	System.out.println("La TimeZone : "+MyTimeZone);		//tz.getRawOffset());
	heure.h=calendarNow.get(Calendar.HOUR_OF_DAY); //+MyTimeZone;	//tz.getRawOffset();
////	if (calendarNow.get(calendarNow.AM_PM)==calendarNow.PM) 	heure.h+=12;
//	//if (heure.h>23)		heure.h-=24;
	heure.m=calendarNow.get(Calendar.MINUTE);	
	heure.s=calendarNow.get(Calendar.SECOND);	
////	heure.h=12; heure.m=00; heure.s=00;
//	String SS="Heure saisie : "+heure.h+":"+heure.m+":"+heure.s;
//	System.out.println(SS);
	heure.ms=0;
}
//---------------------------------------------------------------------------
// 		 ex	TFormMain
//---------------------------------------------------------------------------
void init()
{
	Verbose=true;
	// initialisation...
	ReadConfigFile();
	System.out.println("debug constructeur alloc SalatTimeConfig et Towns ok");
// debug
	GetDate(); GetHeure();
	System.out.println("Recupre la date du systme ok");
}
//---------------------------------------------------------------------------
void ComputeZuhrHour()
{
double Z_GMT, GMST0;
String SS;
	T=JulianCentury (date.j, date.m, date.a, 12);    // pour 12h
	if (Verbose)	{ SS="T="+T+"  JC  12h GMT"; System.out.println(SS);}
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta();
	theta0=TempsSideral( T);
	GMST0=theta0-12.0*heure2rd;
	Z_GMT=rd2heure*(Soleil.RA-GMST0-longitude);
// iteration bis
	if (Z_GMT<0) 	{// si ngatif, on se place  j-1
								Z_GMT+=24;
								T=JulianCentury (date.j-1, date.m, date.a, Z_GMT+24);    // pour LA vraie heure  GWT
								}
		else				T=JulianCentury (date.j, date.m, date.a, Z_GMT);    // pour LA vraie heure  GWT
	if (Verbose)	{ SS="T="+T+"  JC  "+h2hminsec(Z_GMT)+"h GMT"; System.out.println(SS);}
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta();
	theta0=TempsSideral( T);
	GMST0=theta0-Z_GMT*heure2rd;
	SalatTime.Zuhr=MyTimeZone+rd2heure*(Soleil.RA-GMST0-longitude);    // on le prend avec MyTimeZone
	if (SalatTime.Zuhr<0) SalatTime.Zuhr+=24;
}
//---------------------------------------------------------------------------
//compute pour une des 5 prieres
double ComputeTwilightHour(int TypeSalat)	// SalatHour renvoy, si erreur valeur renvoy 100 ou -100
{
double costau;
int Offset=0;
	double SalatHour=0;
	switch (TypeSalat)
		{
		case idFajr : Soleil.h=-SalatTimeConfig[Convention].FajrTwilightAngle*deg2rd;
									Offset=-1;
									break;
		case idIsha : Soleil.h=-SalatTimeConfig[Convention].IshaTwilightAngle*deg2rd;
									Offset=+1;
									break;
		case idChourouk : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=-1;
									break;
		case idMaghrib : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=+1;
									break;
		}
	// commence par calculer au milieur de la journe le T et declinaison du soleil
	// iteration 1
	// debug if (Verbose)	printf(" 1st iter %s\n", h2hminsec(SalatTime.Zuhr-MyTimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatTime.Zuhr-MyTimeZone);    // pour LA vraie heure  GWT
	// debug if (Verbose)		printf("T=%g JC  %s\n", T, h2hminsec(SalatTime.Zuhr-MyTimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta();
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi==1)	Soleil.h=mMath.atan(1.0/(1.0+Math.tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=mMath.atan(1.0/(2.0+Math.tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													Offset=+1;
													}
	costau =(Math.sin(Soleil.h)- Math.sin(latitude)*Math.sin(Soleil.delta))/Math.cos(latitude)/Math.cos(Soleil.delta);
	// debug if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{// debug if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 100;}
	if (costau<-1.0)	{// debug if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -100;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=mMath.acos(costau)/SolarSiderealCorrection;
			SalatHour=SalatTime.Zuhr + Offset*rd2heure*(Soleil.tau);
			// debug if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, h2hminsec( SalatHour, SS));
			}
// corrected values, avec iterations
	// debug if (Verbose)	printf("** corrected values ** :\n");
	// iteration 2
	// debug if (Verbose)	printf(" 2nd iter  %s\n", h2hminsec( SalatHour-MyTimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatHour-MyTimeZone);    // pour LA vraie heure  GWT
	// debug if (Verbose)	printf("T=%g JC  %s\n", T, h2hminsec( SalatHour-MyTimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta();
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi==1)	Soleil.h=mMath.atan(1.0/(1.0+Math.tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
													else			Soleil.h=mMath.atan(1.0/(2.0+Math.tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd*( SalatHour-MyTimeZone);
 	costau =(Math.sin(Soleil.h)- Math.sin(latitude)*Math.sin(Soleil.delta))/Math.cos(latitude)/Math.cos(Soleil.delta);
	// debug if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{// debug if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 100;}
	if (costau<-1.0)	{// debug if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -100;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=mMath.acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			SalatHour=SalatTime.Zuhr + Offset*rd2heure*(Soleil.tau);
			// debug if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, h2hminsec( SalatHour, SS));
			}
	// iteration 3
	// debug if (Verbose)	printf(" 3rd iter  %s\n", h2hminsec( SalatHour-MyTimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatHour-MyTimeZone);    // pour LA vraie heure  GWT
	// debug if (Verbose)	printf("T=%g JC  %s\n", T, h2hminsec( SalatHour-MyTimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta();
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi==1)	Soleil.h=mMath.atan(1.0/(1.0+Math.tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
													else			Soleil.h=mMath.atan(1.0/(2.0+Math.tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													// debug if (Verbose)	printf("h=%g  ie altitude %g\n", Soleil.h*rd2deg, rd2degminsec(Soleil.h, SS));
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd*( SalatHour-MyTimeZone);
	costau =(Math.sin(Soleil.h)- Math.sin(latitude)*Math.sin(Soleil.delta))/Math.cos(latitude)/Math.cos(Soleil.delta);
	// debug if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{// debug if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 100;}
	if (costau<-1.0)	{// debug if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -100;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=mMath.acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			SalatHour=SalatTime.Zuhr + Offset*rd2heure*(Soleil.tau);
			// debug if (Verbose)	printf(" SalatHour=%gh ie : %s\n", SalatHour, h2hminsec( SalatHour, SS));
			}
	return SalatHour;
}
//---------------------------------------------------------------------------
//Appelle les 2 methodes prcdentes pour calculer ttes les prieres
void ComputeSalatTime()
{
String SS;
	System.out.println("Appel ComputeSalatTime");
	System.out.println("Recupre la date du systme ?");
	validSalatTimeC=false;
	DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) MyTimeZone=1+TimeZoneTown;
						else  MyTimeZone=TimeZoneTown;
	// debug if (Verbose)	printf("_____________________________________________________________\n");
	// debug if (Verbose) 	printf("Lieu : %s, %s\n",Towns[TownSelected].CountryName, Towns[TownSelected].TownName);
	// debug if (Verbose) 	printf("latitude=%s   longitude=%s\n", rd2degminsec(latitude, SS),rd2degminsec(longitude, SS2));
	// debug if (Verbose) 	printf((DSTApplies ? "DST Applies": "DST does not apply\n"));
	// debug if (Verbose) 	printf("Convention %d\n", Convention);
	// debug if (Verbose)	printf("____ Mawakit Salat _____\n");
	// debug if (Verbose)	printf(" at Date=: %d/%d/%d   TZ=%d\n", date.j, date.m, date.a, MyTimeZone);
	// Calcul Zuhr
	ComputeZuhrHour();
	// debug if (Verbose)	printf("Passage au mridien (Zuhr)=%gh ie : %s\n", SalatTime.Zuhr, h2hminsec(SalatTime.Zuhr, SS));
	// debug if (Verbose)	printf("\n");
	// lever / coucher
	// debug if (Verbose)	printf("Sunrise / Sunset at -%g", SalatTimeConfig[Convention].Sunrise_setAngle);
	// Calcul Chourouk (lever)
	SalatTime.Chourouk=ComputeTwilightHour( idChourouk);
	// debug error
	if (SalatTime.Chourouk==100 || SalatTime.Chourouk==-100 )	System.out.println("erreur de calcul du Chorouk");

	// debug if (Verbose)	printf("Chourouk (Sunrise) at %gh ie : %s\n", SalatTime.Chourouk, h2hminsec(SalatTime.Chourouk, SS));
	// debug if (Verbose)	printf("\n");
	// Calcul Maghrib (coucher)
	SalatTime.Maghrib=ComputeTwilightHour( idMaghrib);
	if (SalatTime.Maghrib==100 || SalatTime.Maghrib==-100 )	System.out.println("erreur de calcul du Maghrib");
	// debug if (Verbose)	printf("Maghrib (Sunset) at %gh ie : %s\n", SalatTime.Maghrib, h2hminsec(SalatTime.Maghrib, SS));
	// debug if (Verbose)	printf("\n");
	// Calcul Fajr (Twilight)
	SalatTime.Fajr=ComputeTwilightHour( idFajr);
	if (SalatTime.Fajr==100 || SalatTime.Fajr==-100 )	System.out.println("erreur de calcul du Fajr");
	// debug if (Verbose)	printf("Fajr (Twilight) at %gh ie : %s\n", SalatTime.Fajr, h2hminsec(SalatTime.Fajr, SS));
	// debug if (Verbose)	printf("\n");
	// Calcul Isha (Twilight) or Maghrib+
	if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus==1)
						SalatTime.Isha=SalatTime.Maghrib + SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min/60.0;
			else	SalatTime.Isha=ComputeTwilightHour( idIsha);
	if (SalatTime.Isha==100 || SalatTime.Isha==-100 )	System.out.println("erreur de calcul du Isha");
	// debug if (Verbose)	{
	//							if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus==1)
	//										printf("Isha (Maghrib_plus %dmn) at %gh ie : %s\n", SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min, SalatTime.Isha, h2hminsec(SalatTime.Isha, SS));
	//										else printf("Isha (Twilight) at %gh ie : %s\n", SalatTime.Isha, h2hminsec(SalatTime.Isha, SS));
	//							}
	// debug if (Verbose)	printf("\n");
	// Calcul Asr (arccot(1+tan(B-D)))
	SalatTime.Asr=ComputeTwilightHour( idAsr);
	if (SalatTime.Asr==100 || SalatTime.Asr==-100 )	System.out.println("erreur de calcul du Asr");
//	 debug if (Verbose)		System.out.println("Asr (%s) at %gh ie : %s\n", SalatTimeConfig[Convention].AsrShafi>=0 ? "Shafi":"Hanafi", SalatTime.Asr, h2hminsec(SalatTime.Asr, SS));
//	 debug if (Verbose)		System.out.println("\n");

	// calcule les vraies heures de prire
	SalatTimeC.Fajr=SalatTime.Fajr +SalatTimeConfig[Convention].SalatTimeAdjust.Fajr/60.0;
	SalatTimeC.Chourouk=SalatTime.Chourouk +SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk/60.0;
	if (SalatTimeConfig[Convention].ZuhrFixe==1)	SalatTimeC.Zuhr=SalatTimeConfig[Convention].ZuhrFixeHour;
			else SalatTimeC.Zuhr=SalatTime.Zuhr +SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr/60.0;
	SalatTimeC.Asr=SalatTime.Asr +SalatTimeConfig[Convention].SalatTimeAdjust.Asr/60.0;
	SalatTimeC.Maghrib=SalatTime.Maghrib +SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib/60.0;
	SalatTimeC.Isha=SalatTime.Isha  +SalatTimeConfig[Convention].SalatTimeAdjust.Isha/60.0;
	validSalatTimeC=true;
	LastComputeDate.j=calendarNow.get(Calendar.DATE);	
	LastComputeDate.m=calendarNow.get(Calendar.MONTH)+1;
	LastComputeDate.a=calendarNow.get(Calendar.YEAR);
	// check limite de validit de l'exec / bridage
//	if (LastComputeDate.a>limitValidYear)	{limitValid=true; validSalatTimeC=false;}
//			else limitValid=false;
	limitValid=false;	// no limit
	 if (Verbose)		
		{
		System.out.println("_______ Mawakit Salat Exactes _______");
		SS="Fajr    ="+h2hminsec(SalatTime.Fajr);
		if (SalatTimeConfig[Convention].SalatTimeAdjust.Fajr>=0)			SS+=" +";	else	SS+=" ";
		SS+=SalatTimeConfig[Convention].SalatTimeAdjust.Fajr+"mn  "+h2hminsec(SalatTimeC.Fajr);
		System.out.println(SS);

		SS="Chourouk    ="+h2hminsec(SalatTime.Chourouk);
		if (SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk>=0)	SS+=" +";	else	SS+=" ";
		SS+=SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk+"mn  "+h2hminsec(SalatTimeC.Chourouk);
		System.out.println(SS);
	 
		if (SalatTimeConfig[Convention].ZuhrFixe==1)	SS="Zuhr Fixed = "+h2hminsec(SalatTimeC.Zuhr);
							else	{
										SS="Zuhr    ="+h2hminsec(SalatTime.Zuhr);
										if (SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr>=0)			SS+=" +";	else	SS+=" ";
										SS+=SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr+"mn  "+h2hminsec(SalatTimeC.Zuhr);
										}
		System.out.println(SS);
	
		SS="Asr    ="+h2hminsec(SalatTime.Asr);
		if (SalatTimeConfig[Convention].SalatTimeAdjust.Asr>=0)	SS+=" +";	else	SS+=" ";
		SS+=SalatTimeConfig[Convention].SalatTimeAdjust.Asr+"mn  "+h2hminsec(SalatTimeC.Asr);
		System.out.println(SS);
	 
		SS="Maghrib    ="+h2hminsec(SalatTime.Maghrib);
		if (SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib>=0)	SS+=" +";	else	SS+=" ";
		SS+=SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib+"mn  "+h2hminsec(SalatTimeC.Maghrib);
		System.out.println(SS);
	 
		SS="Isha    ="+h2hminsec(SalatTime.Isha);
		if (SalatTimeConfig[Convention].SalatTimeAdjust.Isha>=0)	SS+=" +";	else	SS+=" ";
		SS+=SalatTimeConfig[Convention].SalatTimeAdjust.Isha+"mn  "+h2hminsec(SalatTimeC.Isha);
		System.out.println(SS);
	 
		System.out.println("_______ Mawakit Salat arrondi _______");
		SS="Lieu : "+CountryName+", "+ TownName;
		System.out.println(SS);
		SS="latitude="+rd2degminsec(latitude)+"   longitude="+rd2degminsec(longitude)+" Convention "+Convention;
		System.out.println(SS);
		SS="__ Date : "+Days[CalculeJour(T+(MyTimeZone+12)/24.0/36525.0)]+" "+date.j+"/"+date.m+"/"+date.a+"   ";
		if (DSTApplies)	SS+="DST Applies";	else	SS+="DST does not apply";
		SS+="  TZ (include DST)="+MyTimeZone;
		System.out.println(SS);

		SS="Fajr    ="+h2hmiarrondie(SalatTimeC.Fajr);			System.out.println(SS);
		SS="Chourouk="+h2hmiarrondie(SalatTimeC.Chourouk);	System.out.println(SS);
		SS="Zuhr    ="+h2hmiarrondie(SalatTimeC.Zuhr);			System.out.println(SS);
		SS="Asr     ="+h2hmiarrondie(SalatTimeC.Asr);				System.out.println(SS);
		SS="Maghrib ="+h2hmiarrondie(SalatTimeC.Maghrib);		System.out.println(SS);
		SS="Isha    ="+h2hmiarrondie(SalatTimeC.Isha);			System.out.println(SS);
		System.out.println("_____________________________________");
	}
}
//---------------------------------------------------------------------------
void Calc_haz()
{
String SS;	
	// recupre l'heure et la date  l'instant
	GetDate();
	GetHeure();
	DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) MyTimeZone=1+TimeZoneTown;
						else  MyTimeZone=TimeZoneTown;
	
//???  if (date.j<0) {date.j+=???; date.m--}
	date.h=heure.h-MyTimeZone+heure.m/60.0+heure.s/3600.0;
	if (date.h<0) {date.h+=24; date.j--;}
	System.out.println("_____________  Calc_haz  _________________________");
	SS="Lieu : "+CountryName+", "+ TownName;
	System.out.println(SS);
	SS="latitude="+rd2degminsec(latitude)+"   longitude="+rd2degminsec(longitude);
	System.out.println(SS);
	SS="__ Date : "+Days[CalculeJour(T+(MyTimeZone+12)/24.0/36525.0)]+" "+date.j+"/"+date.m+"/"+date.a+"   "
		+date.h+" h UT    ";
	if (DSTApplies)	SS+="DST Applies";	else	SS+="DST does not apply";
	SS+="  TZ (include DST)="+MyTimeZone;
	System.out.println(SS);
	
	T=JulianCentury (date.j, date.m, date.a, date.h);
	// debug if (Verbose)	printf("T=%g JC\n",T);

	Soleil.L=SoleilLongitude(T);
	System.out.println("Soleil Longitude L="+Soleil.L*rd2deg+" ie : "+rd2hminsec(Soleil.L));
	eclipticL2RA_delta();
	theta0=TempsSideral( T);
	theta=theta0+longitude;
	System.out.println("theta0="+theta0*rd2deg+" ie : "+rd2hminsec(theta0));
	System.out.println("theta="+theta*rd2deg+"  ie heure sidrale "+rd2hminsec(theta));
	Soleil.tau=theta-Soleil.RA;
	System.out.println("RA="+Soleil.RA*rd2deg+" ie : "+ rd2hminsec(Soleil.RA));
	System.out.println("delta="+Soleil.delta*rd2deg+"  ie DE "+rd2degminsec(Soleil.delta));
	System.out.println("tau="+Soleil.tau*rd2deg+"  ie angle horaire "+rd2hminsec(Soleil.tau));
	equatorial2horizontal();
	System.out.println("az="+Soleil.az*rd2deg+" (orgine Sud) ie : azimut "+rd2degminsec(Soleil.az));
	System.out.println("------az="+(Soleil.az*rd2deg-180)+" (orgine Nord) ie -180 : azimut "+rd2degminsec(Soleil.az-M_PI));
	System.out.println("h="+Soleil.h*rd2deg+"  ie altitude "+ rd2degminsec(Soleil.h));
}
//---------------------------------------------------------------------------
void CalculKibla()
{
	double LatitudeM=21.422509756558238*deg2rd;
	double LongitudeM=39.82620120048523*deg2rd;
	thetaKibla =mMath.atan2( Math.sin(LongitudeM-longitude), Math.cos(latitude)*Math.tan(LatitudeM) - Math.sin(latitude)*Math.cos(LongitudeM-longitude));
	System.out.println("_____________  CalculKibla  _________________________");
}
//---------------------------------------------------------------------------
void ReadConfigFile()
{
	System.out.println("Lecture des villes");
//char FileName[]="data.cfg";
//TownData [] ATown;
int TownsCount;

	Convention=0;

	//8 - Conventions
	SalatTimeConfig[Convention].name="User defined";
	SalatTimeConfig[Convention].AsrShafi=1;
	SalatTimeConfig[Convention].FajrTwilightAngle=18;
	SalatTimeConfig[Convention].IshaTwilightAngle=18;
	SalatTimeConfig[Convention].Sunrise_setAngle=0.61;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus=0;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min=90;
	SalatTimeConfig[Convention].ZuhrFixe=0;
	SalatTimeConfig[Convention].ZuhrFixeHour=13.3333334;
	//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	SalatTimeConfig[Convention].SalatTimeAdjust.Fajr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Asr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Isha=0.0;
System.out.println("debug SalatTimeConfig[0] User defined ok");

	Convention++;
//	8 - Conventions
	SalatTimeConfig[Convention].name="France : UOIF";
	SalatTimeConfig[Convention].AsrShafi=1;
	SalatTimeConfig[Convention].FajrTwilightAngle=12;
	SalatTimeConfig[Convention].IshaTwilightAngle=12;
	SalatTimeConfig[Convention].Sunrise_setAngle=0.61;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus=0;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min=0;
	SalatTimeConfig[Convention].ZuhrFixe=0;
	SalatTimeConfig[Convention].ZuhrFixeHour=0;
//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	SalatTimeConfig[Convention].SalatTimeAdjust.Fajr=-5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr=5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Asr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib=5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Isha=5.0;
System.out.println("debug SalatTimeConfig[1] France : UOIF ok");

	Convention++;
	//8 - Conventions
	SalatTimeConfig[Convention].name="Algrie : (18 et Isha 17)";
	SalatTimeConfig[Convention].AsrShafi=1;
	SalatTimeConfig[Convention].FajrTwilightAngle=18;
	SalatTimeConfig[Convention].IshaTwilightAngle=17;
	SalatTimeConfig[Convention].Sunrise_setAngle=0.61;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus=0;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min=90;
	SalatTimeConfig[Convention].ZuhrFixe=0;
	SalatTimeConfig[Convention].ZuhrFixeHour=13.3333334;
	//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	SalatTimeConfig[Convention].SalatTimeAdjust.Fajr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Asr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib=5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Isha=0.0;
System.out.println("debug SalatTimeConfig[2] Algrie : (18 et Isha 17) ok");

	Convention++;
	//8 - Conventions
	SalatTimeConfig[Convention].name="Maroc : (18 et Isha 17)";
	SalatTimeConfig[Convention].AsrShafi=1;
	SalatTimeConfig[Convention].FajrTwilightAngle=18;
	SalatTimeConfig[Convention].IshaTwilightAngle=17;
	SalatTimeConfig[Convention].Sunrise_setAngle=0.61;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus=0;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min=75;
	SalatTimeConfig[Convention].ZuhrFixe=0;
	SalatTimeConfig[Convention].ZuhrFixeHour=13.3333334;
	//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	SalatTimeConfig[Convention].SalatTimeAdjust.Fajr=-5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk=-5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr=5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Asr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib=5.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Isha=0.0;
System.out.println("debug SalatTimeConfig[3] Maroc : (18 et Isha 17");

	Convention++;
	//8 - Conventions
	SalatTimeConfig[Convention].name="Egyptian General Organisation of Surveying";
	SalatTimeConfig[Convention].AsrShafi=1;
	SalatTimeConfig[Convention].FajrTwilightAngle=19.5;
	SalatTimeConfig[Convention].IshaTwilightAngle=17.5;
	SalatTimeConfig[Convention].Sunrise_setAngle=0.61;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus=0;
	SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min=0;
	SalatTimeConfig[Convention].ZuhrFixe=0;
	SalatTimeConfig[Convention].ZuhrFixeHour=0;
	//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	SalatTimeConfig[Convention].SalatTimeAdjust.Fajr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Asr=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib=0.0;
	SalatTimeConfig[Convention].SalatTimeAdjust.Isha=0.0;
System.out.println("debug SalatTimeConfig[3] Egyptian General Organisation of Surveying, ok");

System.out.println("debug All SalatTimeConfig[Convention] red ok");

	
	Countries[0].CountryName="User Def";	Countries[0].TimeZoneTown=0;					Countries[0].DST=0;
	Countries[0].Convention=0;							Countries[0].debut=debut_UserDefined;	Countries[0].fin=fin_UserDefined;
	Countries[1].CountryName="Algrie";			Countries[1].TimeZoneTown=1;					Countries[1].DST=0;
	Countries[1].Convention=2;							Countries[1].debut=debut_Algerie;			Countries[1].fin=fin_Algerie;
	Countries[2].CountryName="Belgique";		Countries[2].TimeZoneTown=1;					Countries[2].DST=1;
	Countries[2].Convention=1;							Countries[2].debut=debut_Belgique;		Countries[2].fin=fin_Belgique;
	Countries[3].CountryName="France";			Countries[3].TimeZoneTown=1;					Countries[3].DST=1;
	Countries[3].Convention=1;							Countries[3].debut=debut_France;			Countries[3].fin=fin_France;
	Countries[4].CountryName="Luxembourg";	Countries[4].TimeZoneTown=1;					Countries[4].DST=1;
	Countries[4].Convention=1;							Countries[4].debut=debut_Luxembourg;	Countries[4].fin=fin_Luxembourg;
	Countries[5].CountryName="Maroc";				Countries[5].TimeZoneTown=0;					Countries[5].DST=0;
	Countries[5].Convention=3;							Countries[5].debut=debut_Maroc;				Countries[5].fin=fin_Maroc;
	Countries[6].CountryName="Tunisie";			Countries[6].TimeZoneTown=1;					Countries[6].DST=0;
	Countries[6].Convention=4;							Countries[6].debut=debut_Tunisie;				Countries[6].fin=fin_Tunisie;
	Countries[7].CountryName="Suisse";			Countries[7].TimeZoneTown=1;					Countries[7].DST=1;
	Countries[7].Convention=1;							Countries[7].debut=debut_Suisse;				Countries[7].fin=fin_Suisse;
	
System.out.println("debug All Countries red ok");

//8 NumberOfTowns  TownSelected  Verbose
//	NTowns=2; fix en statique
	//TownSelected=115;		// Nancy, de database RSE ds la SalatTimeMidlet.startApp 
	Verbose=true;
//	TownsCount=0;

//2 France           Paris            48.86       2.351       1        1   0 
//2 Algrie          Alger            36.75       3.04        1        0   1 
//	Towns[TownsCount].Country=0;	Towns[TownsCount].TownName="Paris";	Towns[TownsCount].latitude=48.86;	Towns[TownsCount].longitude=2.351;	TownsCount++;
//	Towns[TownsCount].Country=0;	Towns[TownsCount].TownName="Nancy";	Towns[TownsCount].latitude=48.7;	Towns[TownsCount].longitude=6.1875;	TownsCount++;
//	Towns[TownsCount].Country=0;	Towns[TownsCount].TownName="Marseille";	Towns[TownsCount].latitude=43.353;	Towns[TownsCount].longitude=5.42767;	TownsCount++;
//	Towns[TownsCount].Country=0;	Towns[TownsCount].TownName="Lyon";	Towns[TownsCount].latitude=45.7578;	Towns[TownsCount].longitude=4.8351;	TownsCount++;
//	Towns[TownsCount].Country=1;	Towns[TownsCount].TownName="Alger";	Towns[TownsCount].latitude=36.75;	Towns[TownsCount].longitude=3.04;	TownsCount++;
//	Towns[TownsCount].Country=1;	Towns[TownsCount].TownName="Tlemcen";	Towns[TownsCount].latitude=34.88;	Towns[TownsCount].longitude=-1.31;TownsCount++;


	System.out.println("Lecture des villes en static !! donc pas ici");

//	if (NTowns != TownsCount) {
//				System.out.println("Number of towns does not match NTowns\n");
//				return;
//				}

	if (TownSelected>=0 && TownSelected<NTowns) {
									longitude=deg2rd*Towns[TownSelected].longitude;
									latitude=deg2rd*Towns[TownSelected].latitude;
									CountryName=Countries[ Towns[TownSelected].Country ].CountryName;
									TownName=Towns[TownSelected].TownName;
									TimeZoneTown=Countries[ Towns[TownSelected].Country ].TimeZoneTown;
									DST=Countries[ Towns[TownSelected].Country ].DST;
									Convention=Countries[ Towns[TownSelected].Country ].Convention;
									if (Verbose)	System.out.println("Lieu actuel : \n");
									if (Verbose)	System.out.println(CountryName + TownName);
									// debug if (Verbose) 	printf("Lieu : %s, %s\n",Towns[TownSelected].CountryName, Towns[TownSelected].TownName);
									// debug if (Verbose) 	printf("latitude=%s   longitude=%s\n", rd2degminsec(latitude, SS),rd2degminsec(longitude, SS2));
									// debug if (Verbose) 	printf("Convention %d\n", Convention);
									}
				else				{
					System.out.println("Error : Selected town out of range");
									return;
									}
}
//---------------------------------------------------------------------------
int CalculeNjdumois(int m, int annee)
{
int Nonbissextile=(annee-4*(int)(annee/4)+2)/3;  // 1 pour une anne commune et  0 pour une bissextile)
	if (m==1 || m==3 || m==5 || m==7
	 || m==8 || m==10 || m==12) 	return 31;
			else	{
						if (m==2) {if (Nonbissextile!=0) return 28;
										else				return 29;
											}
								else  return 30;
				}
}
//---------------------------------------------------------------------------
int CalculeJour(double T) //  pertir du siecle Julien
{
double jour=T*36525+5;   
	return (int)(jour-7*(int)(jour/7));
}
//---------------------------------------------------------------------------
public void updateSelected()
{
	if (TownSelected>=0 && TownSelected<NTowns) {
		longitude=deg2rd*Towns[TownSelected].longitude;
		latitude=deg2rd*Towns[TownSelected].latitude;
		CountryName=Countries[ Towns[TownSelected].Country ].CountryName;
		TownName=Towns[TownSelected].TownName;
		TimeZoneTown=Countries[ Towns[TownSelected].Country ].TimeZoneTown;
		DST=Countries[ Towns[TownSelected].Country ].DST;
		Convention=Countries[ Towns[TownSelected].Country ].Convention;
		if (Verbose)	System.out.println("Lieu actuel : \n");
		if (Verbose)	System.out.println(CountryName + TownName);
		if (Verbose)	System.out.println("latitude "+rd2degminsec(latitude)+"   longitude "+rd2degminsec(longitude));
		if (Verbose)	System.out.println("Convention "+Convention);
		ComputeSalatTime();
		}
		else	{
				System.out.println("Error : Selected town out of range");
				return;
				}
}
//---------------------------------------------------------------------------
//void About1Click()
//{
//char AboutSS[]="SalatTime v1.1\n\n\
//Logiciel de calcul de la position du soleil\n\
//et des heures de prires muslumanes\n\n\
//Ceci est un \"doua3ware\" c'est--dire que,\n\
//si vous tes musulman, merci de prier pour mon salut.\n\n\
//Lotfi BAGHLI (c) 2006";
//	printf( "%s", AboutSS);
//}
//---------------------------------------------------------------------------


}
